(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/http'), require('rxjs'), require('rxjs/add/operator/catch'), require('rxjs/add/operator/toPromise'), require('rxjs/add/operator/debounceTime'), require('rxjs/Observable'), require('rxjs/BehaviorSubject'), require('rxjs/add/operator/map'), require('angular2-logger/core'), require('rxjs/Subject'), require('rxjs/Rx'), require('lodash'), require('@angular/router'), require('primeng/components/breadcrumb/breadcrumb'), require('@angular/common'), require('primeng/primeng'), require('primeng/components/autocomplete/autocomplete'), require('primeng/components/inputtext/inputtext'), require('@angular/forms'), require('primeng/components/datatable/datatable'), require('primeng/components/treetable/treetable')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/http', 'rxjs', 'rxjs/add/operator/catch', 'rxjs/add/operator/toPromise', 'rxjs/add/operator/debounceTime', 'rxjs/Observable', 'rxjs/BehaviorSubject', 'rxjs/add/operator/map', 'angular2-logger/core', 'rxjs/Subject', 'rxjs/Rx', 'lodash', '@angular/router', 'primeng/components/breadcrumb/breadcrumb', '@angular/common', 'primeng/primeng', 'primeng/components/autocomplete/autocomplete', 'primeng/components/inputtext/inputtext', '@angular/forms', 'primeng/components/datatable/datatable', 'primeng/components/treetable/treetable'], factory) :
	(factory((global.ng = global.ng || {}, global.ng.amazing = {}),global.ng.core,global._angular_http,global.rxjs,null,null,null,global.Rx,global.rxjs_BehaviorSubject,global.Rx.Observable.prototype,global.angular2Logger_core,global.rxjs_Subject,global.rxjs_Rx,global._,global._angular_router,global.primeng_components_breadcrumb_breadcrumb,global._angular_common,global.primeng_primeng,global.primeng_components_autocomplete_autocomplete,global.primeng_components_inputtext_inputtext,global._angular_forms,global.primeng_components_datatable_datatable,global.primeng_components_treetable_treetable));
}(this, (function (exports,_angular_core,_angular_http,rxjs,rxjs_add_operator_catch,rxjs_add_operator_toPromise,rxjs_add_operator_debounceTime,rxjs_Observable,rxjs_BehaviorSubject,rxjs_add_operator_map,angular2Logger_core,rxjs_Subject,rxjs_Rx,_,_angular_router,primeng_components_breadcrumb_breadcrumb,_angular_common,primeng_primeng,primeng_components_autocomplete_autocomplete,primeng_components_inputtext_inputtext,_angular_forms,primeng_components_datatable_datatable,primeng_components_treetable_treetable) { 'use strict';

_ = _ && _.hasOwnProperty('default') ? _['default'] : _;

/**
 * Configuration class for dotcms-js. You can extend this class to overide one to many config options and inject
 * the your AppConfig in the app.module ts file of your application
 */
var AppConfig = (function () {
    function AppConfig() {
        this.iconPath = './src/assets/images/icons';
        this.dotCMSURLKey = 'siteURLJWT';
    }
    return AppConfig;
}());

/**
 * NotificationService will notify using Desktop Notifications
 * https://developer.mozilla.org/en-US/docs/Web/API/notification
 * Can change icons by setting iconPath in the AppConfig if needed
 */
var NotificationService = (function () {
    function NotificationService(config) {
        this.config = config;
        this.iconPath = config.iconPath;
    }
    /**
     * Displays an error message
     * @param body
     */
    NotificationService.prototype.displayErrorMessage = function (body) {
        this.displayMessage('Error', body, 'error');
    };
    /**
     * Displays a success message
     * @param body
     */
    NotificationService.prototype.displaySuccessMessage = function (body) {
        this.displayMessage('Success', body, 'success');
    };
    /**
     * Displays an Info message
     * @param body
     */
    NotificationService.prototype.displayInfoMessage = function (body) {
        this.displayMessage('Info', body, 'info');
    };
    /**
     * Display message for passed in type
     * @param title
     * @param body
     * @param type
     */
    NotificationService.prototype.displayMessage = function (title, body, type) {
        var myNotification;
        myNotification = new Notification(type, {
            body: body,
            icon: this.iconPath + '/' + type + '.png'
        });
    };
    return NotificationService;
}());
NotificationService.decorators = [
    { type: _angular_core.Injectable },
    { type: _angular_core.Inject, args: ['config',] },
];
/** @nocollapse */
NotificationService.ctorParameters = function () { return [
    { type: AppConfig, },
]; };
var DotNotificationModule = (function () {
    function DotNotificationModule() {
    }
    return DotNotificationModule;
}());
DotNotificationModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                providers: [AppConfig, NotificationService]
            },] },
];
/** @nocollapse */
DotNotificationModule.ctorParameters = function () { return []; };

/**
 * LocalStoreService. Basic wraper for localStorage
 */
var LocalStoreService = (function () {
    function LocalStoreService() {
    }
    /**
     * Stores Value in localstorage
     * @param key
     * @param value
     */
    LocalStoreService.prototype.storeValue = function (key, value) {
        localStorage.setItem(key, value);
        // storage.set(key, value, callback);
    };
    /**
     * Gets a value from localstorage
     * @param key
     * @returns {any}
     */
    LocalStoreService.prototype.getValue = function (key) {
        return localStorage.getItem(key);
        // return storage.get(key, callback);
    };
    /**
     * Clears a value from localstorage
     * @param key
     */
    LocalStoreService.prototype.clearValue = function (key) {
        localStorage.removeItem(key);
    };
    /**
     * Clears all localstorage
     */
    LocalStoreService.prototype.clear = function () {
        localStorage.clear();
    };
    return LocalStoreService;
}());
LocalStoreService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
LocalStoreService.ctorParameters = function () { return []; };
var DotLocalStoreModule = (function () {
    function DotLocalStoreModule() {
    }
    return DotLocalStoreModule;
}());
DotLocalStoreModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                providers: [LocalStoreService]
            },] },
];
/** @nocollapse */
DotLocalStoreModule.ctorParameters = function () { return []; };

/**
 * Setting Object used by other services and components
 */
var DotSettings = (function () {
    function DotSettings() {
    }
    return DotSettings;
}());

/**
 * Manages the state of objects in dotcms-js so compoents can Observe changes and reload as needed
 */
var SiteBrowserState = (function () {
    function SiteBrowserState() {
        this.currentSiteSubject = new rxjs.BehaviorSubject(null);
        this.currentFolderSubject = new rxjs.BehaviorSubject(null);
        this.currentURISubject = new rxjs.BehaviorSubject(null);
        this.currentTreeableSubject = new rxjs.BehaviorSubject(null);
        this.currentSettingsUpdatedSubject = new rxjs.BehaviorSubject(null);
        this.currentFolder = this.currentFolderSubject.asObservable();
        this.currentSetingsUpdated = this.currentSettingsUpdatedSubject.asObservable();
        this.currentSite = this.currentSiteSubject.asObservable();
        this.currentTreeable = this.currentTreeableSubject.asObservable();
        this.currentURI = this.currentURISubject.asObservable();
    }
    SiteBrowserState.prototype.changeSite = function (siteName) {
        this.currentSiteSubject.next(siteName);
    };
    SiteBrowserState.prototype.getSelectedSite = function () {
        return this.currentSiteSubject.getValue();
    };
    SiteBrowserState.prototype.changeFolder = function (folderName) {
        this.currentFolderSubject.next(folderName);
    };
    SiteBrowserState.prototype.getSelectedFolder = function () {
        return this.currentFolderSubject.getValue();
    };
    SiteBrowserState.prototype.changeURI = function (uri) {
        this.currentURISubject.next(uri);
    };
    SiteBrowserState.prototype.getURI = function () {
        return this.currentURISubject.getValue();
    };
    SiteBrowserState.prototype.changeTreeable = function (treeable) {
        this.currentTreeableSubject.next(treeable);
    };
    SiteBrowserState.prototype.getSelectedTreeable = function () {
        return this.currentTreeableSubject.getValue();
    };
    SiteBrowserState.prototype.changeSettingsUpdated = function (settingsUpdated) {
        this.currentSettingsUpdatedSubject.next(settingsUpdated);
    };
    SiteBrowserState.prototype.getSettingsUpdated = function () {
        return this.currentSettingsUpdatedSubject.getValue();
    };
    return SiteBrowserState;
}());
SiteBrowserState.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
SiteBrowserState.ctorParameters = function () { return []; };

/**
 * Stores and returns the DotSettings class
 */
var SettingsStorageService = (function () {
    function SettingsStorageService(config, localStoreService, siteBrowserState) {
        this.config = config;
        this.localStoreService = localStoreService;
        this.siteBrowserState = siteBrowserState;
        this.configKey = config.dotCMSURLKey;
    }
    SettingsStorageService.prototype.getSettings = function () {
        var dSettings = JSON.parse(this.localStoreService.getValue(this.configKey));
        if (dSettings == null) {
            dSettings = new DotSettings();
        }
        return dSettings;
    };
    /**
     * Stores the DotSettings object
     * @param siteURL
     * @param JWT
     */
    SettingsStorageService.prototype.storeSettings = function (siteURL, JWT) {
        var dSettings = new DotSettings();
        dSettings.site = siteURL;
        dSettings.jwt = JWT;
        this.localStoreService.storeValue(this.configKey, JSON.stringify(dSettings));
    };
    /**
     * removes stored settings
     */
    SettingsStorageService.prototype.clearSettings = function () {
        this.localStoreService.clearValue(this.configKey);
    };
    return SettingsStorageService;
}());
SettingsStorageService.decorators = [
    { type: _angular_core.Injectable },
    { type: _angular_core.Inject, args: ['config',] },
    { type: _angular_core.Inject, args: ['localStoreService',] },
    { type: _angular_core.Inject, args: ['siteBrowserState',] },
];
/** @nocollapse */
SettingsStorageService.ctorParameters = function () { return [
    { type: AppConfig, },
    { type: LocalStoreService, },
    { type: SiteBrowserState, },
]; };
var DotSettingsStorageModule = (function () {
    function DotSettingsStorageModule() {
    }
    return DotSettingsStorageModule;
}());
DotSettingsStorageModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                providers: [SiteBrowserState, AppConfig, LocalStoreService, SettingsStorageService]
            },] },
];
/** @nocollapse */
DotSettingsStorageModule.ctorParameters = function () { return []; };

/**
 * The HTTPClient will use the JWTToken and Host/Site set in the SettingsStorageService to connect dotCMS REST Endpoints
 *
 */
var HttpClient = (function () {
    function HttpClient(http, settingsStorageService) {
        var _this = this;
        this.http = http;
        this.settingsStorageService = settingsStorageService;
        // this.http = http;
        // this.settingsService=settingsService;
        this.progress$ = rxjs.Observable.create(function (observer) {
            _this.progressObserver = observer;
        }).share();
    }
    /**
     * Will append JWT Header to passed in Headers
     * @param headers
     */
    HttpClient.prototype.createAuthorizationHeader = function (headers) {
        if (this.settingsStorageService.getSettings() != null && this.settingsStorageService.getSettings().jwt != null
            && this.settingsStorageService.getSettings().jwt.trim().length > 0) {
            headers.append('Authorization', 'Bearer ' + this.settingsStorageService.getSettings().jwt);
        }
    };
    /**
     * Currently uses a debouce time of 400 and distinctUntilChanged flags on a GET request.  This is intended to
     * limit unecessary requests to the dotCMS Endpoints. Will append needed dotCMS Host/Site and JWT AUth Token
     * @param path Endpoint path
     * @returns {Observable<Response>}
     */
    HttpClient.prototype.get = function (path) {
        var headers = new _angular_http.Headers();
        this.createAuthorizationHeader(headers);
        var site = this.settingsStorageService.getSettings().site;
        return this.http.get((site ? site : '') + path, { headers: headers })
            .debounceTime(400)
            .distinctUntilChanged();
    };
    /**
     * Currently uses a debouce time of 400 and distinctUntilChanged flags on a GET request.  This is intended to
     * limit unecessary requests to the dotCMS Endpoints. Will append needed dotCMS Host/Site and JWT AUth Token
     * @param path path Endpoint path
     * @param data Object to be PUT.  Will be converted to JSON String(JSON.stringify)
     * @returns {Observable<Response>}
     */
    HttpClient.prototype.put = function (path, data) {
        var opts = new _angular_http.RequestOptions();
        opts.method = _angular_http.RequestMethod.Put;
        opts.headers = new _angular_http.Headers({ 'Content-Type': 'application/json' });
        this.createAuthorizationHeader(opts.headers);
        return this.http.put(this.settingsStorageService.getSettings().site + path.toString(), JSON.stringify(data), opts)
            .debounceTime(400)
            .distinctUntilChanged();
    };
    /**
     * Currently uses a debouce time of 400 and distinctUntilChanged flags on a GET request.  This is intended to
     * limit unecessary requests to the dotCMS Endpoints. Will append needed dotCMS Host/Site and JWT AUth Token
     * @param path path Endpoint path
     * @param data Object to be POSTed.  Will be converted to JSON String(JSON.stringify)
     * @returns {Observable<Response>}
     */
    HttpClient.prototype.post = function (path, data) {
        var opts = new _angular_http.RequestOptions();
        opts.method = _angular_http.RequestMethod.Post;
        opts.headers = new _angular_http.Headers({ 'Content-Type': 'application/json' });
        this.createAuthorizationHeader(opts.headers);
        return this.http.post(this.settingsStorageService.getSettings().site + path, JSON.stringify(data), opts);
    };
    /**
     * Intended to simply saving FileAssets to dotCMS. Currently uses a debouce time of 400 and distinctUntilChanged flags on a GET request
     * This is intended to
     * limit unecessary requests to the dotCMS Endpoints. Will append needed dotCMS Host/Site and JWT AUth Token
     * @param path path Endpoint path
     * @param file Binary file to save
     * @param jsonData Object to be POSTed.  Will be converted to JSON String(JSON.stringify)
     * @returns {any}
     */
    HttpClient.prototype.filePut = function (path, file, data) {
        var _this = this;
        return rxjs.Observable.create(function (observer) {
            var formData = new FormData(), xhr = new XMLHttpRequest();
            formData.append('json', JSON.stringify(data));
            formData.append('fileAsset', file);
            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        observer.next(JSON.parse(xhr.response));
                        observer.complete();
                    }
                    else {
                        observer.error(xhr.response);
                    }
                }
            };
            xhr.upload.onprogress = function (event) {
                _this.progress = Math.round(event.loaded / event.total * 100);
                _this.progressObserver.next(_this.progress);
            };
            var site = _this.settingsStorageService.getSettings().site;
            xhr.open('PUT', (site ? site : '') + path.toString(), true);
            if (_this.settingsStorageService.getSettings() != null && _this.settingsStorageService.getSettings().jwt != null
                && _this.settingsStorageService.getSettings().jwt.trim().length > 0) {
                xhr.setRequestHeader('Authorization', 'Bearer ' + _this.settingsStorageService.getSettings().jwt);
            }
            console.log('FormData is ' + formData);
            xhr.send(formData);
        });
    };
    return HttpClient;
}());
HttpClient.decorators = [
    { type: _angular_core.Injectable },
    { type: _angular_core.Inject, args: ['http',] },
    { type: _angular_core.Inject, args: ['settingsStorageService',] },
];
/** @nocollapse */
HttpClient.ctorParameters = function () { return [
    { type: _angular_http.Http, },
    { type: SettingsStorageService, },
]; };
var DotHttpModule = (function () {
    function DotHttpModule() {
    }
    return DotHttpModule;
}());
DotHttpModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                providers: [HttpClient, SettingsStorageService]
            },] },
];
/** @nocollapse */
DotHttpModule.ctorParameters = function () { return []; };

/**
 * Treeable is the parent class/interface for all dotCMS Objects that can live under a Host/Folder
 */
var Treeable = (function () {
    function Treeable() {
    }
    return Treeable;
}());

var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Model object for the FileAsset Object in dotCMS.
 */
var File = (function (_super) {
    __extends(File, _super);
    function File() {
        var _this = _super.call(this) || this;
        _this.displayType = 'File';
        return _this;
    }
    /**
     * Convenience method to check the mimetype and so if it starts with image
     * @returns {boolean}
     */
    File.prototype.isImage = function () {
        return this.mimeType.startsWith('image');
    };
    return File;
}(Treeable));

var FileSearchService = (function () {
    function FileSearchService(httpClient) {
        this.httpClient = httpClient;
        this.searchQuerySubject = new rxjs_BehaviorSubject.BehaviorSubject(null);
        this.searchQuery = this.searchQuerySubject.asObservable();
    }
    FileSearchService.prototype.changeSearchQuery = function (query) {
        this.searchQuerySubject.next(query);
    };
    FileSearchService.prototype.getSearchQuery = function () {
        return this.searchQuerySubject.getValue();
    };
    FileSearchService.prototype.search = function (query) {
        var _this = this;
        return this.httpClient.get('/api/content/render/false/query/' + query)
            .map(function (res) { return _this.extractDataFilter(res); })
            .catch(function (error) { return _this.handleError(error); });
    };
    FileSearchService.prototype.extractDataFilter = function (res) {
        var treeables = [];
        var obj = JSON.parse(res.text());
        var results = obj.contentlets;
        for (var i = 0; i < results.length; i++) {
            var r = results[i];
            var t = void 0;
            t = Object.assign(new File(), r);
            t.modUserName = r.modUser;
            t.mimeType = r.metaData.contentType;
            t.type = 'file_asset';
            treeables[i] = t;
        }
        return treeables;
    };
    FileSearchService.prototype.handleError = function (error) {
        var errMsg = (error.message) ? error.message :
            error.status ? error.status + " - " + error.statusText : 'Server error';
        if (errMsg) {
            // this.log.error(errMsg);
            console.error('There was an error; please try again : ' + errMsg);
            return rxjs_Observable.Observable.throw(errMsg);
        }
    };
    return FileSearchService;
}());
FileSearchService.decorators = [
    { type: _angular_core.Injectable },
    { type: _angular_core.Inject, args: ['httpClient',] },
];
/** @nocollapse */
FileSearchService.ctorParameters = function () { return [
    { type: HttpClient, },
]; };

/**
 * Can be used for CRUD operations on dotCMS FileAssets. Not all CRUD operations are currently implemented
 */
var FileService = (function () {
    function FileService(httpClient, siteBrowserState, notificationService) {
        this.httpClient = httpClient;
        this.siteBrowserState = siteBrowserState;
        this.notificationService = notificationService;
    }
    /**
     * ******  NOT IMPLEMENTED YET *******
     * Will save an array of local files and upload them to dotCMS. The dotCMS file Object will be built by the upload method
     * which means it will not set a Structure/Content Type and will not set the Identifier if the file already exists
     * in dotCMS.  dotCMS will create a new version if the file already exists on the uploaded path or create a new one.
     * The Structure/Content Type is set accordig to the default type on the uploaded dotCMS Folder
     * @param fileList array of file objects to be POSTED to dotCMS
     */
    // TODO : NOT IMPLEMENTED YET
    FileService.prototype.saveFiles = function (fileList) {
    };
    /**
     * Will upload a local file to dotCMS
     * @param file file from teh file System to upload
     * @param path dotCMS Path to upload file to
     */
    FileService.prototype.uploadFile = function (file, path, fileContentTypeID) {
        var data = {
            fileName: file.name,
            hostFolder: this.siteBrowserState.getSelectedSite().hostname + ':' + path,
            stInode: fileContentTypeID,
            title: file.name,
            type: file.type
        };
        this.httpClient.filePut('/api/content/save/1', file, data).subscribe();
    };
    /**
     * Will post to dotCMS an array of the FolderNames to create. If the folder already exists nothing will happen.
     * Even if there are failure it will create the Folders it is able to and log any error on folders it could not create
     * @param directories list of local file System directories to create on dotCMS
     */
    // TODO : SHOULD MOVE TO FolderServices
    FileService.prototype.uploadDirectories = function (directories) {
    };
    FileService.prototype.handleError = function (error) {
        var errMsg = (error.message) ? error.message :
            error.status ? error.status + " - " + error.statusText : 'Server error';
        if (errMsg) {
            console.log(errMsg);
            this.notificationService.displayErrorMessage('There was an error uploading file; please try again : ' + errMsg);
            return rxjs.Observable.throw(errMsg);
        }
    };
    return FileService;
}());
FileService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
FileService.ctorParameters = function () { return [
    { type: HttpClient, },
    { type: SiteBrowserState, },
    { type: NotificationService, },
]; };
var DotFileModule = (function () {
    function DotFileModule() {
    }
    return DotFileModule;
}());
DotFileModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                providers: [HttpClient, NotificationService, FileService, FileSearchService]
            },] },
];
/** @nocollapse */
DotFileModule.ctorParameters = function () { return []; };

/**
 * Service for managing JWT Auth Token from dotCMS Site/Host
 */
var JWTAuthService = (function () {
    function JWTAuthService(http, notificationService, settingsStorageService) {
        this.http = http;
        this.notificationService = notificationService;
        this.settingsStorageService = settingsStorageService;
    }
    /**
     * Will POST to the dotCMS to retrieve a dotCMS Auth Token
     * @param siteURL Site/Host of dotCMS
     * @param username
     * @param password
     * @returns {Observable<R>} String return for the token
     */
    JWTAuthService.prototype.getJWT = function (siteURL, username, password) {
        var _this = this;
        var data = {
            expirationDays: 30,
            password: password,
            user: username,
        };
        return this.doPostAuth(siteURL, data)
            .map(function (res) {
            if (res.status < 200 || res.status >= 300) {
                _this.handleError(res);
                throw new Error('This request has failed ' + res.status);
            }
            return _this.extractJWT(res);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    /**
     * Will login and save the Auth Token to local storage
     * @param siteURL
     * @param username
     * @param password
     * @returns {Observable<R>}
     */
    JWTAuthService.prototype.login = function (siteURL, username, password) {
        var _this = this;
        return this.getJWT(siteURL, username, password)
            .map(function (token) {
            _this.settingsStorageService.storeSettings(siteURL, token);
            return token;
        });
    };
    JWTAuthService.prototype.doPostAuth = function (siteUrl, data) {
        var opts = new _angular_http.RequestOptions();
        opts.method = _angular_http.RequestMethod.Post;
        opts.headers = new _angular_http.Headers({ 'Content-Type': 'application/json' });
        return this.http.post(siteUrl + '/api/v1/authentication/api-token', JSON.stringify(data), opts);
    };
    JWTAuthService.prototype.extractJWT = function (res) {
        var token;
        var obj = JSON.parse(res.text());
        var results = obj.entity.token;
        return results;
    };
    JWTAuthService.prototype.handleError = function (error) {
        var errMsg = (error.message) ? error.message :
            error.status ? error.status + " - " + error.statusText : 'Server error';
        if (errMsg) {
            console.error(errMsg);
            this.notificationService.displayErrorMessage('There was an error; please try again : ' + errMsg);
            return rxjs.Observable.throw(errMsg);
        }
    };
    return JWTAuthService;
}());
JWTAuthService.decorators = [
    { type: _angular_core.Injectable },
    { type: _angular_core.Inject, args: ['http',] },
    { type: _angular_core.Inject, args: ['notificationService',] },
    { type: _angular_core.Inject, args: ['settingsStorageService',] },
];
/** @nocollapse */
JWTAuthService.ctorParameters = function () { return [
    { type: _angular_http.Http, },
    { type: NotificationService, },
    { type: SettingsStorageService, },
]; };
var DotJWTAuthModule = (function () {
    function DotJWTAuthModule() {
    }
    return DotJWTAuthModule;
}());
DotJWTAuthModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                providers: [JWTAuthService]
            },] },
];
/** @nocollapse */
DotJWTAuthModule.ctorParameters = function () { return []; };

var __extends$1 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Model Object for the Folder Object in dotCMS
 */
var Folder = (function (_super) {
    __extends$1(Folder, _super);
    function Folder() {
        var _this = _super.call(this) || this;
        _this.displayType = 'Folder';
        return _this;
    }
    return Folder;
}(Treeable));

/**
 * SiteBrowserService will allows operations against the set dotCMS Site/Host for Tree operations. Treeable assets
 * in dotCMS are anything that live on a host/folder.
 */
var SiteBrowserService = (function () {
    function SiteBrowserService(httpClient, notificationService) {
        this.httpClient = httpClient;
        this.notificationService = notificationService;
    }
    /**
     * Returns the Treeable assets (files, folders) under a host/folder
     * @param siteName dotCMS Site to load assets for
     * @returns {Observable<R>} Gets the Treeable objects. If a file the Treeable will be file as file extends Treeable
     */
    SiteBrowserService.prototype.getTreeableAssetsUnderSite = function (siteName) {
        var _this = this;
        return this.httpClient.get('/api/v1/browsertree/sitename/' + siteName + '/uri//')
            .map(function (res) { return _this.extractDataFilter(res); })
            .catch(function (error) { return _this.handleError(error); });
    };
    /**
     * Returns the Treeable assets (files, folders) under a host/folder
     * @param siteName dotCMS Site to load assets for
     * @param uri Path to load assets from
     * @returns {Observable<R>} Gets the Treeable objects. If a file the Treeable will be file as file extends Treeable
     */
    SiteBrowserService.prototype.getTreeableAssetsUnderFolder = function (siteName, uri) {
        var _this = this;
        return this.httpClient.get('/api/v1/browsertree/sitename/' + siteName + '/uri/' + uri)
            .map(function (res) { return _this.extractDataFilter(res); })
            .catch(function (error) { return _this.handleError(error); });
    };
    SiteBrowserService.prototype.extractDataFilter = function (res) {
        var treeables = [];
        var obj = JSON.parse(res.text());
        var results = obj.entity.result;
        for (var i = 0; i < results.length; i++) {
            var r = results[i];
            var t = void 0;
            if (r.type === 'folder') {
                t = Object.assign(new Folder(), r);
            }
            else if (r.type === 'file_asset') {
                t = Object.assign(new File(), r);
            }
            treeables[i] = t;
        }
        return treeables;
    };
    SiteBrowserService.prototype.handleError = function (error) {
        var errMsg = (error.message) ? error.message :
            error.status ? error.status + " - " + error.statusText : 'Server error';
        if (errMsg) {
            console.error(errMsg);
            this.notificationService.displayErrorMessage('There was an error; please try again : ' + errMsg);
            return rxjs.Observable.throw(errMsg);
        }
    };
    return SiteBrowserService;
}());
SiteBrowserService.decorators = [
    { type: _angular_core.Injectable },
    { type: _angular_core.Inject, args: ['httpClient',] },
    { type: _angular_core.Inject, args: ['notificationService',] },
];
/** @nocollapse */
SiteBrowserService.ctorParameters = function () { return [
    { type: HttpClient, },
    { type: NotificationService, },
]; };
var DotSiteBrowserModule = (function () {
    function DotSiteBrowserModule() {
    }
    return DotSiteBrowserModule;
}());
DotSiteBrowserModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                providers: [SiteBrowserService, HttpClient, NotificationService]
            },] },
];
/** @nocollapse */
DotSiteBrowserModule.ctorParameters = function () { return []; };

/**
 * Service allows opertions against dotCMS Folder Endpoints and Operations
 */
var FolderService = (function () {
    function FolderService(httpClient, notificationService) {
        this.httpClient = httpClient;
        this.notificationService = notificationService;
    }
    /**
     * Load a folder from the remote dotCMS server based on site and path
     * @param {String} siteName The site name for the uri/folder
     * @param {String} uri The folder path
     */
    FolderService.prototype.loadFolderByURI = function (siteName, uri) {
        var _this = this;
        return this.httpClient.get('/api/v1/folder/sitename/' + siteName + '/uri/' + uri)
            .map(function (res) { return _this.extractDataFilter(res); })
            .catch(function (error) { return _this.handleError(error); });
    };
    FolderService.prototype.extractDataFilter = function (res) {
        var folder;
        var obj = JSON.parse(res.text());
        var result = Object.assign(new Folder(), obj.entity);
        return result;
    };
    FolderService.prototype.handleError = function (error) {
        var errMsg = (error.message) ? error.message :
            error.status ? error.status + " - " + error.statusText : 'Server error';
        if (errMsg) {
            console.log(errMsg);
            this.notificationService.displayErrorMessage('There was an error; please try again : ' + errMsg);
            return rxjs_Observable.Observable.throw(errMsg);
        }
    };
    return FolderService;
}());
FolderService.decorators = [
    { type: _angular_core.Injectable },
    { type: _angular_core.Inject, args: ['httpClient',] },
    { type: _angular_core.Inject, args: ['notificationService',] },
];
/** @nocollapse */
FolderService.ctorParameters = function () { return [
    { type: HttpClient, },
    { type: NotificationService, },
]; };
var DotFolderModule = (function () {
    function DotFolderModule() {
    }
    return DotFolderModule;
}());
DotFolderModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                providers: [FolderService, HttpClient, NotificationService]
            },] },
];
/** @nocollapse */
DotFolderModule.ctorParameters = function () { return []; };

/**
 * Created by oswaldogallango on 9/27/16.
 */
var HttpRequestUtils = (function () {
    function HttpRequestUtils() {
    }
    /**
     * Get a map with the url querystring parameters
     * @returns {Map<string, string>}
     */
    // TODO: change the getQueryParams() with an NG2 method equivalent to QueryParams on NGRX.
    HttpRequestUtils.prototype.getQueryParams = function () {
        var split = window.location.search.substring(1).split('&');
        var map = new Map();
        split.forEach(function (param) {
            var paramSplit = param.split('=');
            map.set(paramSplit[0], paramSplit[1]);
        });
        return map;
    };
    /**
     * Get a single parameter form the query string, null if does not exits.
     * it is based on the window.location.href.
     * @returns {string}
     */
    HttpRequestUtils.prototype.getQueryStringParam = function (name) {
        var value = null;
        var regex = new RegExp('[?&]' + name.replace(/[\[\]]/g, '\\$&') + '(=([^&#]*)|&|#|$)');
        var results = regex.exec(window.location.href);
        if (results && results[2]) {
            value = decodeURIComponent(results[2].replace(/\+/g, ' '));
        }
        return value;
    }; // getQueryStringParam.
    return HttpRequestUtils;
}());

/**
 * Encapsulates generic configuration, such as the dev mode, etc.
 * @author jsanca
 */
var Config = (function () {
    function Config() {
        this.httpRequestUtils = new HttpRequestUtils();
    }
    return Config;
}()); // E:O:F:Config
Config.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
Config.ctorParameters = function () { return []; };

/**
 * Encapsulate string utils methods.
 */
var StringUtils = (function () {
    function StringUtils() {
    }
    /**
     * Get from text, the line number (indexLine), null if it does not exists.
     * @param text
     * @param indexLine
     * @returns {string}
     */
    StringUtils.prototype.getLine = function (text, indexLine) {
        var line = null;
        if (text) {
            var lines = text.split('\n');
            line = lines && lines.length > indexLine ? lines[indexLine] : null;
        }
        return line;
    }; // getLine.
    /**
     * Get an string and return it camelcased, ex: "Hello World" > "helloWorld"
     * @param str
     * @returns {string}
     */
    StringUtils.prototype.camelize = function (str) {
        return str
            .replace(/(?:^\w|[A-Z]|\b\w)/g, function (letter, index) {
            return index === 0 ? letter.toLowerCase() : letter.toUpperCase();
        })
            .replace(/\s+/g, '');
    };
    /**
     * Return a string with the first char in uppercase
     *
     * @param {string} str
     * @returns {string}
     *
     * @memberof StringUtils
     */
    StringUtils.prototype.titleCase = function (str) {
        return "" + str.charAt(0).toLocaleUpperCase() + str.slice(1);
    };
    return StringUtils;
}()); // E:O:F:StringUtils.
StringUtils.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
StringUtils.ctorParameters = function () { return []; };

// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.
// The file contents for the current environment will overwrite these during build.
var environment = {
    production: false
};

var DEV_MODE_PARAM = 'devMode';
/**
 * LoggerService to log.  Allows logger to be changed at runtime
 * To set the logger level in the console run logger.level=logger.Level.DEBUG
 */
var LoggerService = (function () {
    function LoggerService(config, logger, stringUtils) {
        this.config = config;
        this.logger = logger;
        this.stringUtils = stringUtils;
        this.showLogs = true;
        logger.info('Setting the logger...');
        this.httpRequestUtils = new HttpRequestUtils();
        this.showLogs = this.shouldShowLogs();
        if (this.showLogs) {
            logger.info('Developer mode logger on');
            logger.level = logger.Level.LOG;
        }
    }
    LoggerService.prototype.info = function (message) {
        var optionalParams = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            optionalParams[_i - 1] = arguments[_i];
        }
        if (optionalParams && optionalParams.length > 0) {
            this.logger.info(this.wrapMessage(message), optionalParams);
        }
        else {
            this.logger.info(this.wrapMessage(message));
        }
    };
    LoggerService.prototype.error = function (message) {
        var optionalParams = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            optionalParams[_i - 1] = arguments[_i];
        }
        if (optionalParams && optionalParams.length > 0) {
            this.logger.error(this.wrapMessage(message), optionalParams);
        }
        else {
            this.logger.error(this.wrapMessage(message));
        }
    };
    LoggerService.prototype.warn = function (message) {
        var optionalParams = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            optionalParams[_i - 1] = arguments[_i];
        }
        if (optionalParams && optionalParams.length > 0) {
            this.logger.warn(this.wrapMessage(message), optionalParams);
        }
        else {
            this.logger.warn(this.wrapMessage(message));
        }
    };
    LoggerService.prototype.debug = function (message) {
        var optionalParams = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            optionalParams[_i - 1] = arguments[_i];
        }
        if (optionalParams && optionalParams.length > 0) {
            this.logger.debug(this.wrapMessage(message), optionalParams);
        }
        else {
            this.logger.debug(this.wrapMessage(message));
        }
    };
    /**
     * Determine if angular should show lo
     * @returns {boolean}
     */
    LoggerService.prototype.shouldShowLogs = function () {
        var devMode = this.httpRequestUtils.getQueryStringParam(DEV_MODE_PARAM);
        return !environment.production || devMode === 'on';
    }; // isProduction.
    LoggerService.prototype.wrapMessage = function (message) {
        // on prod, we do not attach the caller.
        return this.showLogs ? message : this.getCaller() + '>> ' + message;
    };
    LoggerService.prototype.getCaller = function () {
        var caller = 'unknown';
        try {
            throw new Error();
        }
        catch (e) {
            caller = this.cleanCaller(this.stringUtils.getLine(e.stack, 4));
        }
        return caller;
    };
    LoggerService.prototype.cleanCaller = function (caller) {
        return caller ? caller.trim().substr(3) : 'unknown';
    };
    return LoggerService;
}());
LoggerService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
LoggerService.ctorParameters = function () { return [
    { type: Config, },
    { type: angular2Logger_core.Logger, },
    { type: StringUtils, },
]; };

var UserModel = (function () {
    function UserModel(loggerService, localeId) {
        this.loggerService = loggerService;
        this.suppressAlerts = false;
        this.locale = localeId; // default to 'en-US'
        try {
            var url = window.location.search.substring(1);
            this.locale = this.checkQueryForUrl(url);
        }
        catch (e) {
            this.loggerService.error('Could not set locale from URL.');
        }
    }
    UserModel.prototype.checkQueryForUrl = function (locationQuery) {
        var locale = this.locale;
        if (locationQuery && locationQuery.length) {
            var q = locationQuery;
            var token = 'locale=';
            var idx = q.indexOf(token);
            if (idx >= 0) {
                var end = q.indexOf('&', idx);
                end = end !== -1 ? end : q.indexOf('#', idx);
                end = end !== -1 ? end : q.length;
                locale = q.substring(idx + token.length, end);
            }
        }
        return locale;
    };
    return UserModel;
}());
UserModel.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
UserModel.ctorParameters = function () { return [
    { type: LoggerService, },
    { type: undefined, decorators: [{ type: _angular_core.Inject, args: [_angular_core.LOCALE_ID,] },] },
]; };

var ApiRoot = (function () {
    function ApiRoot(authUser, loggerService) {
        this.loggerService = loggerService;
        this.baseUrl = 'http://localhost:8080/';
        this.siteId = '48190c8c-42c4-46af-8d1a-0cd5db894797';
        this.hideFireOn = false;
        this.hideRulePushOptions = false;
        this.authUser = authUser;
        this.authToken = ApiRoot.createAuthToken(authUser);
        try {
            var query = document.location.search.substring(1);
            if (query === '') {
                if (document.location.hash.indexOf('?') >= 0) {
                    query = document.location.hash.substr(document.location.hash.indexOf('?') + 1);
                }
            }
            var siteId = ApiRoot.parseQueryParam(query, 'realmId');
            if (siteId) {
                this.siteId = siteId;
                this.loggerService.debug('Site Id set to ', this.siteId);
            }
            var hideFireOn = ApiRoot.parseQueryParam(query, 'hideFireOn');
            if (hideFireOn) {
                this.hideFireOn = hideFireOn === 'true' || hideFireOn === '1';
                this.loggerService.debug('hideFireOn set to ', this.hideFireOn);
            }
            var hideRulePushOptions = ApiRoot.parseQueryParam(query, 'hideRulePushOptions');
            if (hideRulePushOptions) {
                this.hideRulePushOptions =
                    hideRulePushOptions === 'true' || hideRulePushOptions === '1';
                this.loggerService.debug('hideRulePushOptions set to ', this.hideRulePushOptions);
            }
            var baseUrl = ApiRoot.parseQueryParam(query, 'baseUrl');
            this.loggerService.debug('Proxy server Base URL set to ', baseUrl);
            this.setBaseUrl(baseUrl); // if null, just uses the base of the current URL
            this.configureUser(query, authUser);
        }
        catch (e) {
            this.loggerService.error('Could not set baseUrl automatically.', e);
        }
    }
    ApiRoot.createAuthToken = function (authUser) {
        var token = null;
        if (authUser && authUser.username && authUser.password) {
            token = 'Basic ' + btoa(authUser.username + ':' + authUser.password);
        }
        return token;
    };
    ApiRoot.parseQueryParam = function (query, token) {
        var idx = -1;
        var result = null;
        token = token + '=';
        if (query && query.length) {
            idx = query.indexOf(token);
        }
        if (idx >= 0) {
            var end = query.indexOf('&', idx);
            end = end !== -1 ? end : query.length;
            result = query.substring(idx + token.length, end);
        }
        return result;
    };
    ApiRoot.prototype.getDefaultRequestHeaders = function () {
        var headers = new _angular_http.Headers();
        headers.append('com.dotmarketing.session_host', this.siteId);
        headers.append('Accept', '*/*');
        // headers.append('Accept', 'application/json');
        // headers.append('Content-Type', 'application/json,text/html');
        if (this.authToken) {
            headers.append('Authorization', this.authToken);
        }
        return headers;
    };
    ApiRoot.prototype.getDefaultRequestOptions = function () {
        var headers = new _angular_http.Headers();
        headers.append('com.dotmarketing.session_host', this.siteId);
        if (this.authToken) {
            headers.append('Authorization', this.authToken);
        }
        headers.append('Content-Type', 'application/json');
        return new _angular_http.RequestOptions({
            headers: headers
        });
    };
    ApiRoot.prototype.setBaseUrl = function (url) {
        if (url === void 0) { url = null; }
        if (url === null) {
            // set to same as current request
            var loc = document.location;
            this.baseUrl = loc.protocol + '//' + loc.host + '/';
        }
        else if (url && url.startsWith('http://' || url.startsWith('https://'))) {
            this.baseUrl = url.endsWith('/') ? url : url + '/';
        }
        else {
            throw new Error('Invalid proxy server base url: \'' + url + '\'');
        }
        this.defaultSiteUrl = this.baseUrl + 'api/v1/sites/' + this.siteId;
    };
    ApiRoot.prototype.configureUser = function (query, user) {
        user.suppressAlerts = ApiRoot.parseQueryParam(query, 'suppressAlerts') === 'true';
    };
    return ApiRoot;
}());
ApiRoot.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
ApiRoot.ctorParameters = function () { return [
    { type: UserModel, },
    { type: LoggerService, },
]; };

(function (HttpCode) {
    HttpCode[HttpCode["BAD_REQUEST"] = 400] = "BAD_REQUEST";
    HttpCode[HttpCode["FORBIDDEN"] = 403] = "FORBIDDEN";
    HttpCode[HttpCode["NOT_FOUND"] = 404] = "NOT_FOUND";
    HttpCode[HttpCode["NO_CONTENT"] = 204] = "NO_CONTENT";
    HttpCode[HttpCode["SERVER_ERROR"] = 500] = "SERVER_ERROR";
    HttpCode[HttpCode["UNAUTHORIZED"] = 401] = "UNAUTHORIZED";
})(exports.HttpCode || (exports.HttpCode = {}));

var NETWORK_CONNECTION_ERROR = 1;
var UNKNOWN_RESPONSE_ERROR = 2;
var SERVER_RESPONSE_ERROR = 3;
var CLIENTS_ONLY_MESSAGES = {
    1: 'Could not connect to server.'
};
var CwError = (function () {
    function CwError(code, message, request, response, source) {
        this.code = code;
        this.message = message;
        this.request = request;
        this.response = response;
        this.source = source;
    }
    return CwError;
}());
// tslint:disable-next-line:only-arrow-functions
function isSuccess(resp) {
    return resp.status > 199 && resp.status < 300;
}
// tslint:disable-next-line:only-arrow-functions
function hasContent(resp) {
    return isSuccess(resp) && resp.status !== exports.HttpCode.NO_CONTENT;
}

/**
 *
 *
 * <code>
 * {
 *   "errors":[],
 *   "entity":{},
 *   "messages":[],
 *   "i18nMessagesMap":{}
 * }
 * </code>
 */
var ResponseView = (function () {
    function ResponseView(resp) {
        this.resp = resp;
        try {
            this.bodyJsonObject = resp.json();
            this.headers = resp.headers;
        }
        catch (e) {
            this.bodyJsonObject = {};
        }
    }
    ResponseView.prototype.header = function (headerName) {
        return this.headers.get(headerName);
    };
    Object.defineProperty(ResponseView.prototype, "i18nMessagesMap", {
        get: function () {
            return this.bodyJsonObject.i18nMessagesMap;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResponseView.prototype, "contentlets", {
        get: function () {
            return this.bodyJsonObject.contentlets;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResponseView.prototype, "entity", {
        get: function () {
            return this.bodyJsonObject.entity;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResponseView.prototype, "errorsMessages", {
        get: function () {
            var errorMessages = '';
            if (this.bodyJsonObject.errors) {
                this.bodyJsonObject.errors.forEach(function (e) {
                    errorMessages += e.message;
                });
            }
            else {
                errorMessages = this.bodyJsonObject.message;
            }
            return errorMessages;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResponseView.prototype, "status", {
        get: function () {
            return this.resp.status;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResponseView.prototype, "response", {
        get: function () {
            return this.resp;
        },
        enumerable: true,
        configurable: true
    });
    ResponseView.prototype.existError = function (errorCode) {
        return this.bodyJsonObject.errors &&
            this.bodyJsonObject.errors.filter(function (e) { return e.errorCode === errorCode; }).length > 0;
    };
    return ResponseView;
}());

var BrowserUtil = (function () {
    function BrowserUtil() {
    }
    BrowserUtil.prototype.isIE11 = function () {
        return navigator.appName === 'Netscape' && navigator.appVersion.indexOf('Trident') !== -1;
    };
    return BrowserUtil;
}());
BrowserUtil.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
BrowserUtil.ctorParameters = function () { return []; };

var RULE_CREATE = 'RULE_CREATE';
var RULE_DELETE = 'RULE_DELETE';
var RULE_UPDATE_NAME = 'RULE_UPDATE_NAME';
var RULE_UPDATE_ENABLED_STATE = 'RULE_UPDATE_ENABLED_STATE';
var V_RULE_UPDATE_EXPANDED_STATE = 'V_RULE_UPDATE_EXPANDED_STATE';
var RULE_UPDATE_FIRE_ON = 'RULE_UPDATE_FIRE_ON';
var RULE_RULE_ACTION_CREATE = 'RULE_RULE_ACTION_CREATE';
var RULE_RULE_ACTION_DELETE = 'RULE_RULE_ACTION_DELETE';
var RULE_RULE_ACTION_UPDATE_TYPE = 'RULE_RULE_ACTION_UPDATE_TYPE';
var RULE_RULE_ACTION_UPDATE_PARAMETER = 'RULE_RULE_ACTION_UPDATE_PARAMETER';
var RULE_CONDITION_GROUP_UPDATE_OPERATOR = 'RULE_CONDITION_GROUP_UPDATE_OPERATOR';
var RULE_CONDITION_GROUP_DELETE = 'RULE_CONDITION_GROUP_DELETE';
var RULE_CONDITION_GROUP_CREATE = 'RULE_CONDITION_GROUP_CREATE';
var RULE_CONDITION_CREATE = 'RULE_CONDITION_CREATE';
var RULE_CONDITION_DELETE = 'RULE_CONDITION_DELETE';
var RULE_CONDITION_UPDATE_TYPE = 'RULE_CONDITION_UPDATE_TYPE';
var RULE_CONDITION_UPDATE_PARAMETER = 'RULE_CONDITION_UPDATE_PARAMETER';
var RULE_CONDITION_UPDATE_OPERATOR = 'RULE_CONDITION_UPDATE_OPERATOR';
var CoreWebService = (function () {
    function CoreWebService(_apiRoot, _http, loggerService, browserUtil) {
        this._apiRoot = _apiRoot;
        this._http = _http;
        this.loggerService = loggerService;
        this.browserUtil = browserUtil;
        this.httpErrosSubjects = [];
    }
    CoreWebService.prototype.request = function (options) {
        var _this = this;
        var request = this.getRequestOpts(options);
        var source = options.body;
        return this._http
            .request(request)
            .map(function (resp) {
            return hasContent(resp) ? resp.json() : resp;
        })
            .catch(function (response, original) {
            if (response) {
                _this.handleHttpError(response);
                if (response.status === exports.HttpCode.SERVER_ERROR || response.status === exports.HttpCode.FORBIDDEN) {
                    if (response.text() && response.text().indexOf('ECONNREFUSED') >= 0) {
                        throw new CwError(NETWORK_CONNECTION_ERROR, CLIENTS_ONLY_MESSAGES[NETWORK_CONNECTION_ERROR], request, response, source);
                    }
                    else {
                        throw new CwError(SERVER_RESPONSE_ERROR, response.headers.get('error-message'), request, response, source);
                    }
                }
                else if (response.status === exports.HttpCode.NOT_FOUND) {
                    _this.loggerService.error('Could not execute request: 404 path not valid.', options.url);
                    throw new CwError(UNKNOWN_RESPONSE_ERROR, response.headers.get('error-message'), request, response, source);
                }
            }
            return null;
        });
    };
    /**
   * Return a response adapted to the follow json format:
   *
   * <code>
   * {
   *   "errors":[],
   *   "entity":{},
   *   "messages":[],
   *   "i18nMessagesMap":{}
   * }
   * </code>
   *
   * @param options
   * @returns {DotCMSHttpResponse}
   */
    CoreWebService.prototype.requestView = function (options) {
        var _this = this;
        var request = this.getRequestOpts(options);
        return this._http.request(request)
            .map(function (resp) {
            if (resp.json().errors && resp.json().errors.length > 0) {
                return _this.handleRequestViewErrors(resp);
            }
            else {
                return new ResponseView(resp);
            }
        })
            .catch(this.handleRequestViewErrors);
    };
    CoreWebService.prototype.handleRequestViewErrors = function (resp) {
        return rxjs_Rx.Observable.throw(new ResponseView(resp));
    };
    CoreWebService.prototype.subscribeTo = function (httpErrorCode) {
        if (!this.httpErrosSubjects[httpErrorCode]) {
            this.httpErrosSubjects[httpErrorCode] = new rxjs_Subject.Subject();
        }
        return this.httpErrosSubjects[httpErrorCode].asObservable();
    };
    CoreWebService.prototype.getRequestOpts = function (options) {
        var headers = this._apiRoot.getDefaultRequestHeaders();
        var tempHeaders = options.headers
            ? options.headers
            : { 'Content-Type': 'application/json' };
        Object.keys(tempHeaders).forEach(function (key) {
            headers.set(key, tempHeaders[key]);
        });
        // https://github.com/angular/angular/issues/10612#issuecomment-238712920
        options.body =
            options.body && typeof options.body !== 'string'
                ? JSON.stringify(options.body)
                : options.body ? options.body : '';
        options.headers = headers;
        if (options.url.indexOf('://') === -1) {
            options.url = this._apiRoot.baseUrl + "api/" + options.url;
        }
        if (this.browserUtil.isIE11()) {
            options = options || {};
            options.search = options.search || new _angular_http.URLSearchParams();
            var currentTime = new Date().getTime();
            options.search.set('timestamp', String(currentTime));
        }
        return new _angular_http.Request(options);
    };
    CoreWebService.prototype.handleHttpError = function (response) {
        if (!this.httpErrosSubjects[response.status]) {
            this.httpErrosSubjects[response.status] = new rxjs_Subject.Subject();
        }
        this.httpErrosSubjects[response.status].next(response);
    };
    return CoreWebService;
}());
CoreWebService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
CoreWebService.ctorParameters = function () { return [
    { type: ApiRoot, },
    { type: _angular_http.Http, },
    { type: LoggerService, },
    { type: BrowserUtil, },
]; };

var DOTCMS_WEBSOCKET_RECONNECT_TIME = 'dotcms.websocket.reconnect.time';
var DOTCMS_WEBSOCKET_ENDPOINTS = 'dotcms.websocket.endpoints';
var WEBSOCKET_SYSTEMEVENTS_ENDPOINT = 'websocket.systemevents.endpoint';
var DOTCMS_WEBSOCKET_BASEURL = 'dotcms.websocket.baseurl';
var DOTCMS_WEBSOCKET_PROTOCOL = 'dotcms.websocket.protocol';
var DOTCMS_DISABLE_WEBSOCKET_PROTOCOL = 'dotcms.websocket.disable';
var DOTCMS_PAGINATOR_ROWS = 'dotcms.paginator.rows';
var DOTCMS_PAGINATOR_LINKS = 'dotcms.paginator.links';
var EMAIL_REGEX = 'emailRegex';
var DotcmsConfig = (function () {
    /**
     * Initializes this class with the dotCMS core configuration parameters.
     *
     * @param configParams - The configuration properties for the current instance.
     */
    function DotcmsConfig(coreWebService, loggerService) {
        this.coreWebService = coreWebService;
        this.loggerService = loggerService;
        this.waiting = [];
        this.configUrl = 'v1/appconfiguration';
        this.loadConfig();
    }
    DotcmsConfig.prototype.getConfig = function () {
        var _this = this;
        return rxjs_Rx.Observable.create(function (obs) {
            if (_this.configParams) {
                obs.next(_this.configParams);
            }
            else {
                _this.waiting.push(obs);
            }
        });
    };
    DotcmsConfig.prototype.loadConfig = function () {
        var _this = this;
        this.loggerService.debug('Loading configuration on: ', this.configUrl);
        this.coreWebService
            .requestView({
            method: _angular_http.RequestMethod.Get,
            url: this.configUrl
        })
            .pluck('entity')
            .subscribe(function (res) {
            _this.loggerService.debug('Configuration Loaded!', res);
            _this.configParams = {
                colors: res.config.colors,
                disabledWebsockets: res.config[DOTCMS_DISABLE_WEBSOCKET_PROTOCOL],
                emailRegex: res.config[EMAIL_REGEX],
                license: res.config.license,
                menu: res.menu,
                paginatorLinks: res.config[DOTCMS_PAGINATOR_LINKS],
                paginatorRows: res.config[DOTCMS_PAGINATOR_ROWS],
                websocketBaseURL: res.config[DOTCMS_WEBSOCKET_BASEURL],
                websocketEndpoints: res.config[DOTCMS_WEBSOCKET_ENDPOINTS],
                websocketProtocol: res.config[DOTCMS_WEBSOCKET_PROTOCOL],
                websocketReconnectTime: res.config[DOTCMS_WEBSOCKET_RECONNECT_TIME],
                websocketsSystemEventsEndpoint: res.config[DOTCMS_WEBSOCKET_ENDPOINTS][WEBSOCKET_SYSTEMEVENTS_ENDPOINT]
            };
            _this.loggerService.debug('this.configParams', _this.configParams);
            _this.waiting.forEach(function (obs) { return obs.next(_this.configParams); });
            _this.waiting = null;
            return res;
        });
    };
    return DotcmsConfig;
}());
DotcmsConfig.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
DotcmsConfig.ctorParameters = function () { return [
    { type: CoreWebService, },
    { type: LoggerService, },
]; };

var Url = (function () {
    function Url(protocol, baseUrl, endPoint) {
        this.protocol = protocol;
        this.baseUrl = baseUrl;
        this.endPoint = endPoint;
    }
    Object.defineProperty(Url.prototype, "url", {
        get: function () {
            return this.protocol + "://" + this.baseUrl + this.endPoint;
        },
        enumerable: true,
        configurable: true
    });
    Url.prototype.getHttpUrl = function () {
        return new Url(this.protocol === 'ws' ? 'http' : 'https', this.baseUrl, this.endPoint);
    };
    Url.prototype.getUrlWith = function (queryParameters) {
        var buffer = '';
        // tslint:disable-next-line:forin
        for (var propt in queryParameters) {
            if (buffer.length > 0) {
                buffer += '&';
            }
            buffer += propt + '=' + encodeURIComponent(queryParameters[propt]);
        }
        return this.url + (queryParameters ? '?' + buffer : '');
    };
    return Url;
}());
var Protocol = (function () {
    function Protocol(loggerService, protocolConfig) {
        this.loggerService = loggerService;
        this.protocolConfig = protocolConfig;
        this._open = new rxjs_Subject.Subject();
        this._close = new rxjs_Subject.Subject();
        this._message = new rxjs_Subject.Subject();
        this._error = new rxjs_Subject.Subject();
        if (!protocolConfig) {
            this.protocolConfig = {
                initialTimeout: 500,
                maxTimeout: 300000,
            };
        }
    }
    Protocol.prototype.message$ = function () {
        return this._message.asObservable();
    };
    Protocol.prototype.open$ = function () {
        return this._open.asObservable();
    };
    Protocol.prototype.close$ = function () {
        return this._close.asObservable();
    };
    Protocol.prototype.error$ = function () {
        return this._error.asObservable();
    };
    Protocol.prototype.reconnect = function () {
        this.destroy();
        setTimeout(this.start(), 0);
    };
    // Exponential Backoff Formula by Prof. Douglas Thain
    // http://dthain.blogspot.co.uk/2009/02/exponential-backoff-in-distributed.html
    Protocol.prototype.getBackoffDelay = function (attempt) {
        if (this.protocolConfig && !this.protocolConfig.timeWaitToReconnect) {
            var R = Math.random() + 1;
            var T = this.protocolConfig.initialTimeout;
            var F = 2;
            var N = attempt;
            var M = this.protocolConfig.maxTimeout;
            return Math.floor(Math.min(R * T * Math.pow(F, N), M));
        }
        else {
            return this.protocolConfig.timeWaitToReconnect;
        }
    };
    return Protocol;
}());

var __extends$3 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var WebSocketProtocol = (function (_super) {
    __extends$3(WebSocketProtocol, _super);
    function WebSocketProtocol(url, loggerService, config, protocols) {
        var _this = _super.call(this, loggerService, config) || this;
        _this.url = url;
        _this.protocols = protocols;
        _this.sendQueue = [];
        _this.readyStateConstants = {
            CONNECTING: 0,
            OPEN: 1,
            // tslint:disable-next-line:object-literal-sort-keys
            CLOSING: 2,
            CLOSED: 3,
            RECONNECT_ABORTED: 4
        };
        _this.normalCloseCode = 1000;
        _this.reconnectableStatusCodes = [WebSocketProtocol.AVAILABLE_FOR_USER_WS_CLOSE_STATUS];
        var match = new RegExp('wss?://').test(url.url);
        if (!match) {
            throw new Error('Invalid url provided [' + url.url + ']');
        }
        _this.reconnectIfNotNormalClose =
            config && config.reconnectIfNotNormalClose ? config.reconnectIfNotNormalClose : false;
        _this.dataStream = new rxjs_Subject.Subject();
        return _this;
    }
    WebSocketProtocol.prototype.connect = function (force) {
        var _this = this;
        if (force === void 0) { force = false; }
        var self = this;
        if (force || !this.socket || this.socket.readyState !== this.readyStateConstants.OPEN) {
            this.loggerService.debug('Connecting with Web socket', this.url.url);
            try {
                self.socket = this.protocols
                    ? new WebSocket(this.url.url, this.protocols)
                    : new WebSocket(this.url.url);
                self.socket.onopen = function (ev) {
                    _this.loggerService.debug('Web socket connected', _this.url.url);
                    _this._open.next(ev);
                };
                self.socket.onmessage = function (ev) {
                    _this._message.next(JSON.parse(ev.data));
                };
                self.socket.onclose = function (ev) {
                    if ((_this.reconnectIfNotNormalClose && ev.code !== _this.normalCloseCode) ||
                        _this.reconnectableStatusCodes.indexOf(ev.code) > -1) {
                        _this.loggerService.debug('Reconnecting Web EventsSocket connection');
                        _this.reconnect();
                    }
                    else {
                        _this._close.next(ev);
                        _this._message.complete();
                    }
                };
                self.socket.onerror = function (ev) {
                    _this._error.next(ev);
                };
            }
            catch (error) {
                this.loggerService.debug('Web EventsSocket connection error', error);
                this._error.next(error);
            }
        }
    };
    WebSocketProtocol.prototype.send = function (data) {
        var _this = this;
        if (this.getReadyState() !== this.readyStateConstants.OPEN &&
            this.getReadyState() !== this.readyStateConstants.CONNECTING) {
            this.connect();
        }
        // TODO: change this for an observer
        return new Promise(function (resolve, reject) {
            if (_this.socket.readyState === _this.readyStateConstants.RECONNECT_ABORTED) {
                reject('EventsSocket connection has been closed');
            }
            else {
                _this.sendQueue.push({ message: data });
                _this.fireQueue();
            }
        });
    };
    WebSocketProtocol.prototype.fireQueue = function () {
        while (this.sendQueue.length && this.socket.readyState === this.readyStateConstants.OPEN) {
            var data = this.sendQueue.shift();
            this.socket.send(_.isString(data.message) ? data.message : JSON.stringify(data.message));
            data.deferred.resolve();
        }
    };
    WebSocketProtocol.prototype.close = function (force) {
        if (this.socket && (force || !this.socket.bufferedAmount)) {
            this.socket.close();
        }
        return this;
    };
    WebSocketProtocol.prototype.setInternalState = function (state) {
        if (Math.floor(state) !== state || state < 0 || state > 4) {
            throw new Error('state must be an integer between 0 and 4, got: ' + state);
        }
        this.internalConnectionState = state;
    };
    /**
     * Could be -1 if not initzialized yet
     * @returns {number}
     */
    WebSocketProtocol.prototype.getReadyState = function () {
        if (this.socket == null) {
            return -1;
        }
        return this.internalConnectionState || this.socket.readyState;
    };
    WebSocketProtocol.prototype.start = function () {
        this.connect();
    };
    WebSocketProtocol.prototype.destroy = function () {
        this.loggerService.debug('Closing Web EventsSocket');
        this.close(true);
    };
    return WebSocketProtocol;
}(Protocol));
WebSocketProtocol.AVAILABLE_FOR_USER_WS_CLOSE_STATUS = 4000;

var __extends$4 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var LongPollingProtocol = (function (_super) {
    __extends$4(LongPollingProtocol, _super);
    function LongPollingProtocol(url, loggerService, coreWebService, queryBuilder) {
        var _this = _super.call(this, loggerService) || this;
        _this.url = url;
        _this.coreWebService = coreWebService;
        _this.queryBuilder = queryBuilder;
        _this.isClosed = false;
        if (!queryBuilder) {
            _this.queryBuilder = function (data) { return null; };
        }
        return _this;
    }
    LongPollingProtocol.prototype.start = function (queryParameters) {
        var _this = this;
        this.isClosed = false;
        this.loggerService.info('Starting long polling connection');
        this.coreWebService
            .requestView({
            method: _angular_http.RequestMethod.Get,
            url: this.url.getUrlWith(queryParameters)
        })
            .pluck('entity')
            .subscribe(function (data) {
            _this.loggerService.debug('new Events', data);
            if (data instanceof Array) {
                data.forEach(function (message) {
                    _this._message.next(message);
                });
            }
            else {
                _this._message.next(data);
            }
            if (!_this.isClosed) {
                var query = _this.queryBuilder(data);
                _this.start(query);
            }
        }, function () {
            _this.loggerService.info('A error occur connecting through long polling');
            if (!_this.isClosed) {
                _this.start();
            }
        });
    };
    LongPollingProtocol.prototype.destroy = function () {
        this.loggerService.info('destroying long polling');
        this.isClosed = true;
    };
    return LongPollingProtocol;
}(Protocol));

var __extends$2 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var CONNECTION_STATUS;
(function (CONNECTION_STATUS) {
    CONNECTION_STATUS[CONNECTION_STATUS["NONE"] = 0] = "NONE";
    CONNECTION_STATUS[CONNECTION_STATUS["CONNECTING"] = 1] = "CONNECTING";
    CONNECTION_STATUS[CONNECTION_STATUS["CONNECTED"] = 2] = "CONNECTED";
    CONNECTION_STATUS[CONNECTION_STATUS["CLOSED"] = 3] = "CLOSED";
})(CONNECTION_STATUS || (CONNECTION_STATUS = {}));
var WEB_SOCKET_SERVER_SUPPORT;
(function (WEB_SOCKET_SERVER_SUPPORT) {
    WEB_SOCKET_SERVER_SUPPORT[WEB_SOCKET_SERVER_SUPPORT["NOT_SUPPORTED"] = 0] = "NOT_SUPPORTED";
    WEB_SOCKET_SERVER_SUPPORT[WEB_SOCKET_SERVER_SUPPORT["SUPPORTED"] = 1] = "SUPPORTED";
    WEB_SOCKET_SERVER_SUPPORT[WEB_SOCKET_SERVER_SUPPORT["DONT_NOW"] = 2] = "DONT_NOW";
})(WEB_SOCKET_SERVER_SUPPORT || (WEB_SOCKET_SERVER_SUPPORT = {}));
var EventsSocket = (function (_super) {
    __extends$2(EventsSocket, _super);
    /**
     * Initializes this service with the configuration properties that are
     * necessary for opening the Websocket with the System Events end-point.
     *
     * @param dotcmsConfig - The dotCMS configuration properties that include
     * the Websocket parameters.
     */
    function EventsSocket(url, configParams, loggerService, coreWebService) {
        var _this = _super.call(this, loggerService, {
            timeWaitToReconnect: configParams.websocketReconnectTime
        }) || this;
        _this.url = url;
        _this.coreWebService = coreWebService;
        _this.closedOnLogout = false;
        _this.isWebSocketServerSupport = WEB_SOCKET_SERVER_SUPPORT.DONT_NOW;
        _this.status = CONNECTION_STATUS.NONE;
        _this.isWebSocketServerSupport = configParams.disabledWebsockets
            ? WEB_SOCKET_SERVER_SUPPORT.NOT_SUPPORTED
            : WEB_SOCKET_SERVER_SUPPORT.DONT_NOW;
        return _this;
    }
    EventsSocket.prototype.start = function () {
        var _this = this;
        if (!this.protocolImpl && this.url) {
            this.loggerService.debug('Creating a new socket connection', this.url.url);
            this.protocolImpl = this.getProtocol();
            this.status = CONNECTION_STATUS.CONNECTING;
            this.protocolImpl.start();
            this.protocolImpl.open$().subscribe(function () {
                if (_this.isWebSocketProtocol()) {
                    _this.isWebSocketServerSupport = WEB_SOCKET_SERVER_SUPPORT.SUPPORTED;
                }
                _this.status = CONNECTION_STATUS.CONNECTED;
                _this._open.next();
            });
            this.protocolImpl.error$().subscribe(function (error) {
                if (_this.status === CONNECTION_STATUS.CONNECTING && _this.isWebSocketProtocol()) {
                    _this.loggerService.info('Error connecting with Websockets, trying again with long polling');
                    _this.status = CONNECTION_STATUS.NONE;
                    _this.isWebSocketServerSupport = WEB_SOCKET_SERVER_SUPPORT.NOT_SUPPORTED;
                    _this.protocolImpl = null;
                    _this.start();
                }
                else {
                    _this._error.next(error);
                }
            });
            this.protocolImpl.close$().subscribe(function (event) {
                if (_this.closedOnLogout) {
                    // We explicitly closed the socket
                    // If we closed the socket for a logout we need to reset the closedOnLogout flag
                    _this.closedOnLogout = false;
                    _this.protocolImpl = null; // Cleaning up the socket as we explicitly closed the socket
                }
                else if (_this.status === CONNECTION_STATUS.CONNECTED) {
                    // Something happened and we need to try a reconnection
                    _this.reconnect();
                }
                _this.status = CONNECTION_STATUS.CLOSED;
            });
            this.protocolImpl
                .message$()
                .subscribe(function (res) { return _this._message.next(res); }, function (e) {
                return _this.loggerService.debug('Error in the System Events service: ' + e.message);
            }, function () { return _this.loggerService.debug('Completed'); });
        }
    };
    EventsSocket.prototype.destroy = function () {
        // On logout, meaning no authenticated user lets try to close the socket
        if (this.protocolImpl) {
            this.loggerService.debug('Closing socket');
            this.closedOnLogout = true;
            this.protocolImpl.destroy();
            this._close.next();
        }
    };
    EventsSocket.prototype.getProtocol = function () {
        var _this = this;
        var isWebSocketBrowserSupport = this.isWebSocketsBrowserSupport();
        if (isWebSocketBrowserSupport &&
            this.isWebSocketServerSupport !== WEB_SOCKET_SERVER_SUPPORT.NOT_SUPPORTED) {
            return new WebSocketProtocol(this.url, this.loggerService);
        }
        else {
            return new LongPollingProtocol(this.url.getHttpUrl(), this.loggerService, this.coreWebService, function (data) {
                var result = {};
                if (data.length > 0) {
                    _this.lastcallback = data[data.length - 1].creationDate + 1;
                    result.lastcallback = _this.lastcallback;
                }
                else if (_this.lastcallback) {
                    result.lastcallback = _this.lastcallback;
                }
                return result;
            });
        }
    };
    EventsSocket.prototype.isWebSocketsBrowserSupport = function () {
        return 'WebSocket' in window || 'MozWebSocket' in window;
    };
    EventsSocket.prototype.isWebSocketProtocol = function () {
        return this.protocolImpl instanceof WebSocketProtocol;
    };
    return EventsSocket;
}(Protocol));

var SocketFactory = (function () {
    function SocketFactory(dotcmsConfig, loggerService, coreWebService) {
        this.dotcmsConfig = dotcmsConfig;
        this.loggerService = loggerService;
        this.coreWebService = coreWebService;
    }
    SocketFactory.prototype.createSocket = function () {
        var _this = this;
        this.loggerService.debug('Creating socket object');
        return rxjs_Rx.Observable.create(function (observer) {
            _this.dotcmsConfig.getConfig().subscribe(function (configParams) {
                var url = new Url(configParams.websocketProtocol, configParams.websocketBaseURL, configParams.websocketsSystemEventsEndpoint);
                if (!_this.socket) {
                    _this.socket = new EventsSocket(url, configParams, _this.loggerService, _this.coreWebService);
                }
                observer.next(_this.socket);
                observer.complete();
            });
        });
    };
    SocketFactory.prototype.clean = function () {
        this.socket = null;
    };
    return SocketFactory;
}());
SocketFactory.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
SocketFactory.ctorParameters = function () { return [
    { type: DotcmsConfig, },
    { type: LoggerService, },
    { type: CoreWebService, },
]; };

var DotcmsEventsService = (function () {
    function DotcmsEventsService(socketFactory, loggerService) {
        this.socketFactory = socketFactory;
        this.loggerService = loggerService;
        this.subjects = [];
    }
    /**
     * Close the socket
     */
    DotcmsEventsService.prototype.destroy = function () {
        this.socket.destroy();
        this.socketFactory.clean();
        this.socket = null;
    };
    /**
     * Start the socket
     */
    DotcmsEventsService.prototype.start = function () {
        var _this = this;
        this.loggerService.debug('start DotcmsEventsService');
        if (!this.socket) {
            this.socketFactory.createSocket().subscribe(function (socket) {
                _this.socket = socket;
                socket.message$().subscribe(function (data) {
                    if (!_this.subjects[data.event]) {
                        _this.subjects[data.event] = new rxjs_Subject.Subject();
                    }
                    _this.subjects[data.event].next(data.payload);
                }, function (e) {
                    _this.loggerService.debug('Error in the System Events service: ' + e.message);
                }, function () {
                    _this.loggerService.debug('Completed');
                });
                _this.loggerService.debug('Connecting with socket');
                socket.start();
            });
        }
    };
    /**
     * This method will be called by clients that want to receive notifications
     * regarding incoming system events. The events they will receive will be
     * based on the type of event clients register for.
     *
     * @param clientEventType - The type of event clients will get. For example,
     *                          "notification" will allow a client to receive the
     *                          messages in the Notification section.
     * @returns {any} The system events that a client will receive.
     */
    DotcmsEventsService.prototype.subscribeTo = function (clientEventType) {
        if (!this.subjects[clientEventType]) {
            this.subjects[clientEventType] = new rxjs_Subject.Subject();
        }
        return this.subjects[clientEventType].asObservable();
    };
    DotcmsEventsService.prototype.subscribeToEvents = function (clientEventTypes) {
        var _this = this;
        var subject = new rxjs_Subject.Subject();
        clientEventTypes.forEach(function (eventType) {
            return _this.subscribeTo(eventType).subscribe(function (data) {
                return subject.next({
                    data: data,
                    eventType: eventType
                });
            });
        });
        return subject.asObservable();
    };
    return DotcmsEventsService;
}());
DotcmsEventsService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
DotcmsEventsService.ctorParameters = function () { return [
    { type: SocketFactory, },
    { type: LoggerService, },
]; };

/**
 * Created by oswaldogallango on 7/11/16.
 */
/**
 * This Service get the server configuration to display in the login component
 * and execute the login and forgot password routines
 */
var LoginService = (function () {
    function LoginService(router, coreWebService, dotcmsEventsService, loggerService) {
        var _this = this;
        this.router = router;
        this.coreWebService = coreWebService;
        this.dotcmsEventsService = dotcmsEventsService;
        this.loggerService = loggerService;
        this._auth$ = new rxjs_Subject.Subject();
        this._logout$ = new rxjs_Subject.Subject();
        this.country = '';
        this.lang = '';
        this.nUsers = -1;
        this._loginAsUsersList$ = new rxjs_Subject.Subject();
        this.urls = {
            changePassword: 'v1/changePassword',
            getAuth: 'v1/authentication/logInUser',
            loginAs: 'v1/users/loginas',
            logout: 'v1/logout',
            logoutAs: 'v1/users/logoutas',
            recoverPassword: 'v1/forgotpassword',
            serverInfo: 'v1/loginform',
            userAuth: 'v1/authentication'
        };
        // when the session is expired/destroyed
        dotcmsEventsService.subscribeTo('SESSION_DESTROYED').pluck('data').subscribe(function (date) {
            _this.loggerService.debug('Processing session destroyed: ', date);
            _this.loggerService.debug('User Logged In Date: ', _this.auth.user.loggedInDate);
            // if the destroyed event happens after the logged in date, so proceed!
            if (_this.isLogoutAfterLastLogin(date)) {
                _this.logOutUser().subscribe(function () { });
            }
        });
    }
    Object.defineProperty(LoginService.prototype, "loginAsUsersList$", {
        get: function () {
            return this._loginAsUsersList$.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoginService.prototype, "auth$", {
        get: function () {
            return this._auth$.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoginService.prototype, "logout$", {
        get: function () {
            return this._logout$.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoginService.prototype, "auth", {
        get: function () {
            return this._auth;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoginService.prototype, "isLogin$", {
        get: function () {
            var _this = this;
            return rxjs_Rx.Observable.if(function () { return !!_this.auth && !!_this.auth.user; }, rxjs_Rx.Observable.of(true), this.loadAuth().map(function (auth) { return !!auth && !!auth.user; }));
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Load _auth information.
     * @returns {Observable<any>}
     */
    LoginService.prototype.loadAuth = function () {
        var _this = this;
        return this.coreWebService
            .requestView({
            method: _angular_http.RequestMethod.Get,
            url: this.urls.getAuth
        })
            .pluck('entity')
            .do(function (auth) {
            if (auth.user) {
                _this.setAuth(auth);
            }
        })
            .map(function (auth) { return auth; });
    };
    /**
     * Change password
     * @param password
     * @param token
     * @returns {Observable<any>}
     */
    LoginService.prototype.changePassword = function (password, token) {
        var body = JSON.stringify({ password: password, token: token });
        return this.coreWebService.requestView({
            body: body,
            method: _angular_http.RequestMethod.Post,
            url: this.urls.changePassword
        });
    };
    /**
     * Get the server information to configure the login component
     * @param language language and country to get the internationalized messages
     * @param i18nKeys array of message key to internationalize
     * @returns {Observable<any>} Observable with an array of internationalized messages and server configuration info
     */
    LoginService.prototype.getLoginFormInfo = function (language, i18nKeys) {
        this.setLanguage(language);
        return this.coreWebService.requestView({
            body: { messagesKey: i18nKeys, language: this.lang, country: this.country },
            method: _angular_http.RequestMethod.Post,
            url: this.urls.serverInfo
        });
    };
    /**
     * Do the login as request and return an Observable.
     * @param user user to loginas
     * @param password loginin user's password
     * @returns {Observable<R>}
     */
    // TODO: password in the url is a no-no, fix asap. Sanchez and Jose have an idea.
    LoginService.prototype.loginAs = function (userData) {
        var _this = this;
        return this.coreWebService
            .requestView({
            body: {
                password: userData.password,
                userId: userData.user.userId
            },
            method: _angular_http.RequestMethod.Post,
            url: this.urls.loginAs
        })
            .map(function (res) {
            if (!res.entity.loginAs) {
                throw res.errorsMessages;
            }
            _this.setAuth({
                loginAsUser: userData.user,
                user: _this._auth.user,
                isLoginAs: true
            });
            return res;
        })
            .pluck('entity', 'loginAs');
    };
    /**
     * Executes the call to the login rest api
     * @param login User email or user id
     * @param password User password
     * @param rememberMe boolean indicating if the _auth want to use or not the remenber me option
     * @param language string with the language and country code, ex: en_US
     * @returns an array with the user if the user logged in successfully or the error message
     */
    LoginService.prototype.loginUser = function (login, password, rememberMe, language) {
        var _this = this;
        this.setLanguage(language);
        return this.coreWebService
            .requestView({
            body: {
                userId: login,
                password: password,
                rememberMe: rememberMe,
                language: this.lang,
                country: this.country
            },
            method: _angular_http.RequestMethod.Post,
            url: this.urls.userAuth
        })
            .map(function (response) {
            var auth = {
                loginAsUser: null,
                user: response.entity,
                isLoginAs: false
            };
            _this.setAuth(auth);
            _this.coreWebService
                .subscribeTo(exports.HttpCode.UNAUTHORIZED)
                .subscribe(function () { return _this.logOutUser().subscribe(function () { }); });
            return response.entity;
        });
    };
    /**
     * Logout "login as" user
     * @returns {Observable<R>}
     */
    LoginService.prototype.logoutAs = function () {
        var _this = this;
        return this.coreWebService
            .requestView({
            method: _angular_http.RequestMethod.Put,
            url: "" + this.urls.logoutAs
        })
            .map(function (res) {
            _this.setAuth({
                loginAsUser: null,
                user: _this._auth.user,
                isLoginAs: true
            });
            return res;
        });
    };
    /**
     * Call the logout rest api
     * @returns {Observable<any>}
     */
    LoginService.prototype.logOutUser = function () {
        var _this = this;
        return this.coreWebService
            .requestView({
            method: _angular_http.RequestMethod.Get,
            url: this.urls.logout
        })
            .map(function (response) {
            var nullAuth = {
                loginAsUser: null,
                user: null,
                isLoginAs: false
            };
            _this.loggerService.debug('Processing the logOutUser');
            _this.setAuth(nullAuth);
            // on logout close the websocket
            _this.dotcmsEventsService.destroy();
            _this.loggerService.debug('Navigating to Public Login');
            _this.router.navigate(['/public/login']);
        });
    };
    /**
     * Executes the call to the recover passwrod rest api
     * @param email User email address
     * @returns an array with message indicating if the recover password was successfull
     * or if there is an error
     */
    LoginService.prototype.recoverPassword = function (login) {
        return this.coreWebService.requestView({
            body: { userId: login },
            method: _angular_http.RequestMethod.Post,
            url: this.urls.recoverPassword
        });
    };
    /**
     * Subscribe to ser change and call received function on change.
     * @param func function will call when user change
     */
    LoginService.prototype.watchUser = function (func) {
        if (this.auth) {
            func(this.auth);
        }
        this.auth$.subscribe(function (auth) {
            if (auth.user) {
                func(auth);
            }
        });
    };
    /**
     * Set logged_auth and update auth Observable
     * @param _auth
     */
    LoginService.prototype.setAuth = function (auth) {
        this._auth = auth;
        this._auth$.next(auth);
        // When not logged user we need to fire the observable chain
        if (!auth.user) {
            this._logout$.next();
        }
        else {
            this.dotcmsEventsService.start();
        }
    };
    LoginService.prototype.isLogoutAfterLastLogin = function (date) {
        return (this.auth.user &&
            this.auth.user.loggedInDate &&
            date &&
            Number(date) > Number(this.auth.user.loggedInDate));
    };
    /**
     * update the language and country variables from the string
     * @param language string containing the language and country
     */
    LoginService.prototype.setLanguage = function (language) {
        if (language !== undefined && language !== '') {
            var languageDesc = language.split('_');
            this.lang = languageDesc[0];
            this.country = languageDesc[1];
        }
        else {
            this.lang = '';
            this.country = '';
        }
    };
    /**
     * Request and store the login as _auth list.
     */
    LoginService.prototype.loadLoginAsUsersList = function (includeNUsers, filter) {
        return this.coreWebService
            .requestView({
            method: _angular_http.RequestMethod.Get,
            url: this.urls
                .loginAsUserList + "?includeUsersCount=" + includeNUsers + "&filter=" + filter
        })
            .pluck('entity');
    };
    return LoginService;
}());
LoginService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
LoginService.ctorParameters = function () { return [
    { type: _angular_router.Router, },
    { type: CoreWebService, },
    { type: DotcmsEventsService, },
    { type: LoggerService, },
]; };

/**
 * Provide methods and data to hable the sites.
 * @export
 * @class SiteService
 */
var SiteService = (function () {
    function SiteService(loginService, dotcmsEventsService, coreWebService, loggerService) {
        var _this = this;
        this.coreWebService = coreWebService;
        this.loggerService = loggerService;
        this.events = [
            'SAVE_SITE',
            'PUBLISH_SITE',
            'UPDATE_SITE_PERMISSIONS',
            'UN_ARCHIVE_SITE',
            'UPDATE_SITE',
            'ARCHIVE_SITE'
        ];
        this._switchSite$ = new rxjs_Subject.Subject();
        this._refreshSites$ = new rxjs_Subject.Subject();
        this.urls = {
            currentSiteUrl: 'v1/site/currentSite',
            sitesUrl: 'v1/site',
            switchSiteUrl: 'v1/site/switch'
        };
        dotcmsEventsService
            .subscribeToEvents(['ARCHIVE_SITE', 'UPDATE_SITE'])
            .subscribe(function (data) { return _this.eventResponse(data); });
        dotcmsEventsService
            .subscribeToEvents(this.events)
            .subscribe(function (data) { return _this.siteEventsHandler(data); });
        loginService.watchUser(function (auth) {
            if (!auth.isLoginAs) {
                _this.loadCurrentSite();
            }
        });
    }
    /**
     * Manage the response when an event happen
     * @param {void} eventTypeWrapper
     * @returns {*}
     * @memberof SiteService
     */
    SiteService.prototype.eventResponse = function (eventTypeWrapper) {
        this.loggerService.debug('Capturing Site event', eventTypeWrapper.eventType, eventTypeWrapper.data);
        // TODO the backend needs a change in the response 'data.data'.
        var siteIdentifier = eventTypeWrapper.data.data.identifier;
        if (siteIdentifier === this.selectedSite.identifier) {
            if (eventTypeWrapper.eventType !== 'ARCHIVE_SITE') {
                this.loadCurrentSite();
            }
        }
    };
    /**
     * Refresh the sites list if a event happen
     * @param {any} eventTypeWrapper
     * @memberof SiteService
     */
    SiteService.prototype.siteEventsHandler = function (eventTypeWrapper) {
        this._refreshSites$.next(eventTypeWrapper.data.data);
    };
    Object.defineProperty(SiteService.prototype, "refreshSites$", {
        /**
         * Observable trigger when an site event happens
         * @readonly
         * @type {Observable<Site>}
         * @memberof SiteService
         */
        get: function () {
            return this._refreshSites$.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SiteService.prototype, "switchSite$", {
        /**
         * Observable tigger when the current site is changed
         * @readonly
         * @type {Observable<Site>}
         * @memberof SiteService
         */
        get: function () {
            return this._switchSite$.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SiteService.prototype, "currentSite", {
        /**
         * Return the current site for the login user.
         * @readonly
         * @type {Site}
         * @memberof SiteService
         */
        get: function () {
            return this.selectedSite;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Switch To Default Site in the BE and returns it.
     *
     * @returns {Observable<Site>}
     * @memberof SiteService
     */
    SiteService.prototype.switchToDefaultSite = function () {
        return this.coreWebService
            .requestView({
            method: _angular_http.RequestMethod.Put,
            url: 'v1/site/switch'
        })
            .pluck('entity');
    };
    /**
     * Get a site by the id
     *
     * @param {string} id
     * @returns {Observable<Site>}
     * @memberof SiteService
     */
    SiteService.prototype.getSiteById = function (id) {
        return this.coreWebService
            .requestView({
            method: _angular_http.RequestMethod.Get,
            url: "content/render/false/query/+contentType:host%20+identifier:" + id
        })
            .pluck('contentlets')
            .map(function (sites) { return sites[0]; });
    };
    /**
     * Change the current site
     * @param {Site} site
     * @memberof SiteService
     */
    SiteService.prototype.switchSite = function (site) {
        var _this = this;
        this.loggerService.debug('Applying a Site Switch', site.identifier);
        this.coreWebService
            .requestView({
            method: _angular_http.RequestMethod.Put,
            url: this.urls.switchSiteUrl + "/" + site.identifier
        })
            .subscribe(function () { return _this.setCurrentSite(site); });
    };
    SiteService.prototype.setCurrentSite = function (site) {
        if (this.selectedSite) {
            this._switchSite$.next(Object.assign({}, site));
        }
        this.selectedSite = site;
    };
    SiteService.prototype.loadCurrentSite = function () {
        var _this = this;
        this.coreWebService
            .requestView({
            method: _angular_http.RequestMethod.Get,
            url: this.urls.currentSiteUrl
        })
            .pluck('entity')
            .subscribe(function (currentSite) {
            _this.setCurrentSite(currentSite);
        });
    };
    SiteService.prototype.getOneSite = function () {
        return this.coreWebService
            .requestView({
            method: _angular_http.RequestMethod.Get,
            url: this.urls.sitesUrl
        })
            .map(function (response) {
            return response.entity[0];
        });
    };
    return SiteService;
}());
SiteService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
SiteService.ctorParameters = function () { return [
    { type: LoginService, },
    { type: DotcmsEventsService, },
    { type: CoreWebService, },
    { type: LoggerService, },
]; };

var DotRouterService = (function () {
    function DotRouterService(router, loginService) {
        this.router = router;
        this.loginService = loginService;
    }
    DotRouterService.prototype.goToMain = function () {
        this.router.navigate(['/c']);
    };
    DotRouterService.prototype.goToLogin = function (parameters) {
        this.router.navigate(['/public/login'], parameters);
    };
    DotRouterService.prototype.goToURL = function (url) {
        this.router.navigate([url]);
    };
    DotRouterService.prototype.isPublicUrl = function (url) {
        return url.startsWith('/public');
    };
    DotRouterService.prototype.isFromCoreUrl = function (url) {
        return url.startsWith('/fromCore');
    };
    DotRouterService.prototype.isRootUrl = function (url) {
        return url === '/';
    };
    DotRouterService.prototype.gotoPortlet = function (portletId) {
        this.router.navigate(["c/" + portletId.replace(' ', '_')]);
    };
    DotRouterService.prototype.goToForgotPassword = function () {
        this.router.navigate(['/public/forgotPassword']);
    };
    DotRouterService.prototype.goToNotLicensed = function () {
        this.router.navigate(['c/notLicensed']);
    };
    return DotRouterService;
}());
DotRouterService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
DotRouterService.ctorParameters = function () { return [
    { type: _angular_router.Router, },
    { type: LoginService, },
]; };

var RoutingService = (function () {
    // TODO: I think we should be able to remove the routing injection
    function RoutingService(loginService, router, coreWebService, dotcmsEventsService) {
        this.router = router;
        this.coreWebService = coreWebService;
        this._menusChange$ = new rxjs_Subject.Subject();
        this._portletUrlSource$ = new rxjs_Subject.Subject();
        this._currentPortlet$ = new rxjs_Subject.Subject();
        this.urlMenus = 'v1/CORE_WEB/menu';
        this.portlets = new Map();
        loginService.watchUser(this.loadMenus.bind(this));
        dotcmsEventsService
            .subscribeTo('UPDATE_PORTLET_LAYOUTS')
            .subscribe(this.loadMenus.bind(this));
    }
    Object.defineProperty(RoutingService.prototype, "currentPortletId", {
        get: function () {
            return this._currentPortletId;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RoutingService.prototype, "currentMenu", {
        get: function () {
            return this.menus;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RoutingService.prototype, "menusChange$", {
        get: function () {
            return this._menusChange$.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RoutingService.prototype, "portletUrl$", {
        get: function () {
            return this._portletUrlSource$.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RoutingService.prototype, "firstPortlet", {
        get: function () {
            var porlets = this.portlets.entries().next().value;
            return porlets ? porlets[0] : null;
        },
        enumerable: true,
        configurable: true
    });
    RoutingService.prototype.addPortletURL = function (portletId, url) {
        this.portlets.set(portletId.replace(' ', '_'), url);
    };
    RoutingService.prototype.getPortletURL = function (portletId) {
        return this.portlets.get(portletId);
    };
    RoutingService.prototype.goToPortlet = function (portletId) {
        this.router.gotoPortlet(portletId);
        this._currentPortletId = portletId;
    };
    RoutingService.prototype.isPortlet = function (url) {
        var id = this.getPortletId(url);
        if (id.indexOf('?') >= 0) {
            id = id.substr(0, id.indexOf('?'));
        }
        return this.portlets.has(id);
    };
    RoutingService.prototype.setCurrentPortlet = function (url) {
        var id = this.getPortletId(url);
        if (id.indexOf('?') >= 0) {
            id = id.substr(0, id.indexOf('?'));
        }
        this._currentPortletId = id;
        this._currentPortlet$.next(id);
    };
    Object.defineProperty(RoutingService.prototype, "currentPortlet$", {
        get: function () {
            return this._currentPortlet$;
        },
        enumerable: true,
        configurable: true
    });
    RoutingService.prototype.setMenus = function (menus) {
        this.menus = menus;
        if (this.menus.length) {
            this.portlets = new Map();
            for (var i = 0; i < this.menus.length; i++) {
                var menu = this.menus[i];
                for (var k = 0; k < menu.menuItems.length; k++) {
                    var subMenuItem = menu.menuItems[k];
                    if (subMenuItem.angular) {
                        this.portlets.set(subMenuItem.id, subMenuItem.url);
                    }
                    else {
                        subMenuItem.menuLink = '/c/' + subMenuItem.id;
                        this.portlets.set(subMenuItem.id, subMenuItem.url);
                    }
                }
            }
            this._menusChange$.next(this.menus);
        }
    };
    /**
     * Refresh the portlet displayed. with the
     * @param url portlet url
     */
    RoutingService.prototype.changeRefreshPortlet = function (url) {
        var portletId = this.getPortletId(url);
        if (portletId === this.currentPortletId) {
            this._portletUrlSource$.next(url);
        }
    };
    RoutingService.prototype.loadMenus = function () {
        var _this = this;
        this.coreWebService
            .requestView({
            method: _angular_http.RequestMethod.Get,
            url: this.urlMenus
        })
            .subscribe(function (response) {
            _this.setMenus(response.entity);
        }, function (error) { return _this._menusChange$.error(error); });
    };
    RoutingService.prototype.getPortletId = function (url) {
        var urlSplit = url.split('/');
        return urlSplit[urlSplit.length - 1];
    };
    return RoutingService;
}());
RoutingService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
RoutingService.ctorParameters = function () { return [
    { type: LoginService, },
    { type: DotRouterService, },
    { type: CoreWebService, },
    { type: DotcmsEventsService, },
]; };

/**
 * The BreadcrumbComponent provides a PrimeNG Component for providing navigation with dotCMS Components
 * It can respond to the Site or Folder being changed.  In addition the navigation it provides can be clicked on
 * There is no connection to the other components directly.  The interaction is all managed by the [[SiteBrowserState]]
 */
var BreadcrumbComponent = (function () {
    function BreadcrumbComponent(updateService) {
        var _this = this;
        this.updateService = updateService;
        this.buildMenuItemsFromURI(this.updateService.getURI());
        updateService.currentSite.subscribe(function (site) {
            _this.onSiteChange(site);
        });
        updateService.currentFolder.subscribe(function (folderName) {
            _this.onFolderClick(folderName);
        });
        updateService.currentURI.subscribe(function (uri) {
            _this.buildMenuItemsFromURI(uri);
        });
    }
    /**
     * Called when the [[SiteBrowserState]] Site is changed. This is managed via a Subscription
     * @param siteName
     */
    BreadcrumbComponent.prototype.onSiteChange = function (site) {
        this.pathItems = [];
        this.addSiteItem(site);
    };
    /**
     * Called when the [[SiteBrowserState]] Folder is changed. This is managed via a Subscription
     * @param folderName
     */
    BreadcrumbComponent.prototype.onFolderClick = function (folderName) {
        if (!folderName) {
            return;
        }
        var uri = this.getCurrentURI() + '/' + folderName;
        this.addFolderItem(folderName);
    };
    BreadcrumbComponent.prototype.getCurrentURI = function () {
        var uri = '';
        for (var i = 1; i < this.pathItems.length; i++) {
            var pi = this.pathItems[i];
            uri = uri + '/' + pi.label;
        }
        return uri;
    };
    BreadcrumbComponent.prototype.addSiteItem = function (site) {
        var _this = this;
        this.pathItems.push({
            command: function (event) {
                _this.updateService.changeSite(site);
                _this.updateService.changeURI(null);
                _this.updateService.changeFolder(null);
                setTimeout(function () {
                }, 100);
            }, label: site ? site.hostname : ''
        });
    };
    BreadcrumbComponent.prototype.addFolderItem = function (folderName) {
        var _this = this;
        var currentURI = this.getCurrentURI();
        this.pathItems.push({
            command: function (event) {
                _this.updateService.changeURI(currentURI + '/' + folderName);
                setTimeout(function () {
                }, 100);
            }, label: folderName
        });
    };
    BreadcrumbComponent.prototype.buildMenuItemsFromURI = function (uri) {
        this.pathItems = [];
        var site = this.updateService.getSelectedSite();
        if (!site || !site.hostname) {
            return;
        }
        this.addSiteItem(site);
        if (uri) {
            var folders = uri.split('/');
            for (var i = 0; i < folders.length; i++) {
                this.onFolderClick(folders[i]);
            }
        }
    };
    return BreadcrumbComponent;
}());
BreadcrumbComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'breadcrumb',
                styles: [require('./../app.css')],
                template: "<p-breadcrumb [model]=\"pathItems\"></p-breadcrumb>"
            },] },
    { type: _angular_core.Inject, args: ['updateService',] },
];
/** @nocollapse */
BreadcrumbComponent.ctorParameters = function () { return [
    { type: SiteBrowserState, },
]; };
var DotBreadcrumbModule = (function () {
    function DotBreadcrumbModule() {
    }
    return DotBreadcrumbModule;
}());
DotBreadcrumbModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                declarations: [BreadcrumbComponent],
                exports: [BreadcrumbComponent],
                imports: [_angular_common.CommonModule, primeng_components_breadcrumb_breadcrumb.BreadcrumbModule],
                providers: []
            },] },
];
/** @nocollapse */
DotBreadcrumbModule.ctorParameters = function () { return []; };

var SiteSelectorService = (function () {
    function SiteSelectorService(dotHttpClient, notificationService) {
        this.dotHttpClient = dotHttpClient;
        this.notificationService = notificationService;
    }
    /**
     * Returns a list of sites searcing the hostname
     * @param searchQuery
     * @returns {Observable<R|T>}
     */
    SiteSelectorService.prototype.filterForSites = function (searchQuery) {
        var _this = this;
        return this.dotHttpClient.get('/api/v1/site?filter=' + searchQuery + '&archived=false')
            .map(function (res) { return _this.extractDataFilter(res); })
            .catch(function (err) { return _this.handleError(err); });
    };
    /**
     * Returns all sites
     * @returns {Observable<R|T>}
     */
    SiteSelectorService.prototype.getSites = function () {
        var _this = this;
        return this.dotHttpClient.get('/api/v1/site/')
            .map(function (res) { return _this.extractDataDropdown(res); })
            .catch(function (err) { return _this.handleError(err); });
    };
    SiteSelectorService.prototype.extractDataDropdown = function (res) {
        var obj = JSON.parse(res.text());
        if (obj.entity.sites && obj.entity.sites.results && obj.entity.sites.results.length > 0) {
            return obj.entity.sites.results;
        }
        return obj.entity;
    };
    SiteSelectorService.prototype.extractDataFilter = function (res) {
        var obj = JSON.parse(res.text());
        return obj.entity;
    };
    SiteSelectorService.prototype.handleError = function (error) {
        // we need use a remote logging infrastructure at some point
        var errMsg = (error.message) ? error.message :
            error.status ? error.status + " - " + error.statusText : 'Server error';
        if (errMsg) {
            console.log(errMsg);
            this.notificationService.displayErrorMessage('There was an error; please try again : ' + errMsg);
            return rxjs.Observable.throw(errMsg);
        }
    };
    return SiteSelectorService;
}());
SiteSelectorService.decorators = [
    { type: _angular_core.Injectable },
    { type: _angular_core.Inject, args: ['dotHttpClient',] },
    { type: _angular_core.Inject, args: ['notificationService',] },
];
/** @nocollapse */
SiteSelectorService.ctorParameters = function () { return [
    { type: HttpClient, },
    { type: NotificationService, },
]; };

var SiteSelectorComponent = (function () {
    function SiteSelectorComponent(updateService, siteSelectorService) {
        this.updateService = updateService;
        this.siteSelectorService = siteSelectorService;
        this.host = updateService.getSelectedSite();
    }
    /**
     * Is called when a site is selected in the dropdown
     * @param event
     */
    SiteSelectorComponent.prototype.siteSelected = function (event) {
        this.updateService.changeSite(this.host);
    };
    /**
     * Is called as the user tyoes in the filtering select
     * @param event
     */
    SiteSelectorComponent.prototype.filterHosts = function (event) {
        var _this = this;
        this.siteSelectorService.filterForSites(event.query)
            .subscribe(function (sites) { return _this.handleSiteResults(sites, event); });
        setTimeout(function () { }, 100);
    };
    /**
     * Is called when the user clicks to view all sites in the dropdown
     */
    SiteSelectorComponent.prototype.handleDropdownClick = function () {
        var _this = this;
        this.filteredHosts = [];
        this.siteSelectorService.getSites()
            .subscribe(function (sites) { return _this.handleSiteResults(sites); });
        setTimeout(function () { }, 100);
    };
    SiteSelectorComponent.prototype.handleSiteResults = function (hosts, event) {
        if (event === void 0) { event = 0; }
        this.filteredHosts = [];
        this.sites = hosts;
        for (var i = 0; i < this.sites.length; i++) {
            var site = this.sites[i];
            if (event && site.hostname.toLowerCase().indexOf(event.query.toLowerCase()) === 0) {
                this.filteredHosts.push(site);
            }
            else {
                this.filteredHosts[i] = this.sites[i];
            }
        }
    };
    return SiteSelectorComponent;
}());
SiteSelectorComponent.decorators = [
    { type: _angular_core.Inject, args: ['updateService',] },
    { type: _angular_core.Component, args: [{
                selector: 'site-selector',
                styles: [require('./../app.css')],
                template: "<div>\n        <p-autoComplete [(ngModel)]=\"host\" [suggestions]=\"filteredHosts\" (completeMethod)=\"filterHosts($event)\"\n                        [size]=\"30\"\n                        [minLength]=\"1\" placeholder=\"Hint: type 'd'\" [dropdown]=\"true\"\n                        (onDropdownClick)=\"handleDropdownClick($event)\"\n                        (onSelect)=\"siteSelected($event)\" field=\"hostname\">\n            <ng-template let-host pTemplate=\"item\">\n                <div class=\"ui-helper-clearfix\" style=\"border-bottom:1px solid #D5D5D5\">\n                    <div style=\"font-size:18px;float:right;margin:10px 10px 0 0\">{{host.hostname}}</div>\n                </div>\n            </ng-template>\n        </p-autoComplete>\n    </div>"
            },] },
];
/** @nocollapse */
SiteSelectorComponent.ctorParameters = function () { return [
    { type: SiteBrowserState, },
    { type: SiteSelectorService, },
]; };
var DotSiteSelectorModule = (function () {
    function DotSiteSelectorModule() {
    }
    return DotSiteSelectorModule;
}());
DotSiteSelectorModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                declarations: [SiteSelectorComponent],
                exports: [SiteSelectorComponent],
                imports: [_angular_common.CommonModule, _angular_forms.FormsModule, primeng_components_inputtext_inputtext.InputTextModule, primeng_components_autocomplete_autocomplete.AutoCompleteModule],
                providers: [SiteSelectorService]
            },] },
];
/** @nocollapse */
DotSiteSelectorModule.ctorParameters = function () { return []; };

/**
 * The BreadcrumbComponent provides a PrimeNG Component for providing navigation with dotCMS Components
 * It can respond to the Site or Folder being changed.  In addition the navigation it provides can be clicked on
 * There is no connection to the other components directly.  The interaction is all managed by the [[SiteBrowserState]]
 * Unlike the breadcrumb component this component has a built in site selector
 */
var BreadcrumbHostselectorComponent = (function () {
    function BreadcrumbHostselectorComponent(updateService, fileSearchService) {
        var _this = this;
        this.updateService = updateService;
        this.fileSearchService = fileSearchService;
        this.homeItem = { label: 'Host Select', command: function (event) { _this.openHostSelectDialog(); } };
        this.buildMenuItemsFromURI(this.updateService.getURI());
        updateService.currentSite.subscribe(function (site) {
            _this.onSiteChange(site);
        });
        updateService.currentFolder.subscribe(function (folderName) {
            _this.onFolderClick(folderName);
        });
        updateService.currentURI.subscribe(function (uri) {
            _this.buildMenuItemsFromURI(uri);
        });
    }
    BreadcrumbHostselectorComponent.prototype.openHostSelectDialog = function () {
        this.hostDialog = true;
    };
    BreadcrumbHostselectorComponent.prototype.closeHostSelect = function () {
        this.hostDialog = false;
    };
    /**
     * Called when the [[SiteBrowserState]] Site is changed. This is managed via a Subscription
     * @param siteName
     */
    BreadcrumbHostselectorComponent.prototype.onSiteChange = function (site) {
        this.pathItems = [];
        this.addSiteItem(site);
        this.closeHostSelect();
    };
    /**
     * Called when the [[SiteBrowserState]] Folder is changed. This is managed via a Subscription
     * @param folderName
     */
    BreadcrumbHostselectorComponent.prototype.onFolderClick = function (folderName) {
        if (!folderName) {
            return;
        }
        var uri = this.getCurrentURI() + '/' + folderName;
        this.addFolderItem(folderName);
    };
    BreadcrumbHostselectorComponent.prototype.getCurrentURI = function () {
        var uri = '';
        for (var i = 1; i < this.pathItems.length; i++) {
            var pi = this.pathItems[i];
            uri = uri + '/' + pi.label;
        }
        return uri;
    };
    BreadcrumbHostselectorComponent.prototype.addSiteItem = function (site) {
        var _this = this;
        this.pathItems.push({
            command: function (event) {
                _this.updateService.changeSite(site);
                _this.updateService.changeURI(null);
                _this.updateService.changeFolder(null);
                _this.fileSearchService.changeSearchQuery(null);
                setTimeout(function () {
                }, 100);
            }, label: site ? site.hostname : ''
        });
    };
    BreadcrumbHostselectorComponent.prototype.addFolderItem = function (folderName) {
        var _this = this;
        var currentURI = this.getCurrentURI();
        this.pathItems.push({
            command: function (event) {
                _this.updateService.changeURI(currentURI + '/' + folderName);
                setTimeout(function () {
                }, 100);
            }, label: folderName
        });
    };
    BreadcrumbHostselectorComponent.prototype.buildMenuItemsFromURI = function (uri) {
        this.pathItems = [];
        var site = this.updateService.getSelectedSite();
        if (!site || !site.hostname) {
            return;
        }
        this.addSiteItem(site);
        if (uri) {
            var folders = uri.split('/');
            for (var i = 0; i < folders.length; i++) {
                this.onFolderClick(folders[i]);
            }
        }
    };
    return BreadcrumbHostselectorComponent;
}());
BreadcrumbHostselectorComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'app-breadcrumb-hostselector',
                template: "<p-breadcrumb [home]=\"homeItem\" [model]=\"pathItems\"></p-breadcrumb>\n    <p-dialog header=\"Select Host\" [contentStyle]=\"{'overflow':'visible'}\" [closable]=\"true\" [(visible)]=\"hostDialog\" [responsive]=\"true\" showEffect=\"fade\" [modal]=\"true\" (onAfterHide)=\"closeHostSelect()\" width=\"500\">\n      <site-selector></site-selector>\n    </p-dialog>"
            },] },
    { type: _angular_core.Inject, args: ['updateService',] },
];
/** @nocollapse */
BreadcrumbHostselectorComponent.ctorParameters = function () { return [
    { type: SiteBrowserState, },
    { type: FileSearchService, },
]; };
var DotBreadcrumbHostselectorModule = (function () {
    function DotBreadcrumbHostselectorModule() {
    }
    return DotBreadcrumbHostselectorModule;
}());
DotBreadcrumbHostselectorModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                declarations: [BreadcrumbHostselectorComponent],
                exports: [BreadcrumbHostselectorComponent],
                imports: [_angular_common.CommonModule, primeng_primeng.BreadcrumbModule, primeng_primeng.DialogModule, DotSiteSelectorModule],
                providers: []
            },] },
];
/** @nocollapse */
DotBreadcrumbHostselectorModule.ctorParameters = function () { return []; };

/**
 * The SiteDataTableComponent is a PrimeNG Component which provides a DataTable to display dotCMS Host/Folder Navigation
 * The Component is Supscribed to the [[SiteBrowserState]] to monitor when Folders and Site changes occur
 * In additiont to this it will respond to dragging Files and Folders from the local filesystem and upload them to dotCMS
 * The SiteDataTableComponent is able to display [[Treeable]] assets
 */
var SiteDatatableComponent = (function () {
    function SiteDatatableComponent(updateService, fileService, siteBrowserService, settingsStorageService, messageService) {
        var _this = this;
        this.updateService = updateService;
        this.fileService = fileService;
        this.siteBrowserService = siteBrowserService;
        this.settingsStorageService = settingsStorageService;
        this.messageService = messageService;
        this.dotCMSURL = '';
        if (settingsStorageService.getSettings()) {
            this.dotCMSURL = settingsStorageService.getSettings().site;
        }
        this.site = updateService.getSelectedSite();
        if (updateService.getURI()) {
            this.loadFolder(updateService.getURI());
        }
        updateService.currentSite
            .subscribe(function (site) {
            if (site && site.hostname) {
                _this.loadSite(site);
            }
        });
        updateService.currentURI
            .subscribe(function (uri) {
            if (uri) {
                _this.loadFolder(uri);
            }
        });
        setTimeout(function () {
        }, 100);
    }
    /**
     * Listens to the double click event.  If the row clicked is a folder the [[SiteBrowserState]] will be called to
     * change the folder. This will cause this component to load the new folder and of course anyone else
     * subscribed to the [[SiteBrowserState]] folder state
     * @param event
     */
    SiteDatatableComponent.prototype.doubleClick = function (event) {
        if (event.data.type !== 'folder') {
            return;
        }
        var pathName = event.data.path;
        pathName = pathName.slice(0, pathName.length - 1);
        pathName = pathName.slice(pathName.lastIndexOf('/') + 1, pathName.length);
        this.updateService.changeFolder(pathName);
        this.updateService.changeURI(event.data.path);
        var folder = event.data;
        var uri = this.updateService.getURI();
        if (!uri) {
            uri = '';
        }
        this.loadFolder(folder.path);
        setTimeout(function () {
        }, 100);
    };
    /**
     * On single click of a row this function will update the [[SiteBrowserState]] selected [[Treeable]]
     * @param event
     */
    SiteDatatableComponent.prototype.selectTreeable = function (event) {
        this.updateService.changeTreeable(event.data);
    };
    /**
     * This function is called when the [[SiteBrowserState]] uri is changed
     * @param uri
     */
    SiteDatatableComponent.prototype.loadFolder = function (uri) {
        var _this = this;
        this.siteBrowserService.getTreeableAssetsUnderFolder(this.site.hostname, uri)
            .subscribe(function (treeables) { return _this.treeables = treeables; });
        setTimeout(function () { }, 100);
    };
    /**
     * This function is called when the [[SiteBrowserState]] Site is changed
     * @param siteName
     */
    SiteDatatableComponent.prototype.loadSite = function (site) {
        var _this = this;
        this.site = site;
        this.siteBrowserService.getTreeableAssetsUnderSite(site.hostname)
            .subscribe(function (treeables) { return _this.treeables = treeables; });
        setTimeout(function () { }, 100);
    };
    SiteDatatableComponent.prototype.handleDragOver = function (e) { };
    /**
     * Deals with the drop of 1 to many files and folders from the filesystem
     * @param e
     * @returns {boolean}
     */
    SiteDatatableComponent.prototype.handleDrop = function (e) {
        e.preventDefault();
        var pathToUploadTo;
        var fileContentTypeID;
        var dataTrans = e.dataTransfer;
        var fileName = e.dataTransfer.files[0].name;
        var files = e.dataTransfer.files;
        var folderTitle = e.path[0].innerText.trim();
        for (var i = 0; i < this.treeables.length; i++) {
            var node = this.treeables[i];
            if (node.title === folderTitle && node.type === 'folder') {
                pathToUploadTo = node.path;
                fileContentTypeID = node.defaultFileType;
                break;
            }
        }
        for (var i = 0; i < files.length; i++) {
            var file = files[i];
            if (fileContentTypeID == null || fileContentTypeID.trim() === '') {
                console.error('st inode is empty');
            }
            this.fileService.uploadFile(file, pathToUploadTo, fileContentTypeID);
        }
        this.messageService.displayInfoMessage('Path is ' + pathToUploadTo);
        return;
    };
    return SiteDatatableComponent;
}());
SiteDatatableComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'site-datatable',
                styles: [require('./../app.css')],
                template: "<div (drop)=\"handleDrop($event, p-column)\" (dragover)=\"handleDragOver($event)\">\n        <p-dataTable [value]=\"treeables\" selectionMode=\"single\"\n                     (onRowDblclick)=\"doubleClick($event)\" (onRowSelect)=\"selectTreeable($event)\">\n            <p-column class=\"browser-dropzone\" field=\"title\" header=\"Name\" [sortable]=\"true\">\n                <ng-template let-col let-treeable=\"rowData\" pTemplate type=\"body\">\n                <span [ngSwitch]=\"treeable.type\">\n                    <span *ngSwitchCase=\"'folder'\" class=\"{{treeable.type=='folder' ? 'fa fa-folder aria-hidden=true':''}}\"></span>\n                    <span *ngSwitchCase=\"'file_asset'\">\n                        <img *ngIf=\"treeable.isImage() && treeable.extension!='ico'\" src=\"{{dotCMSURL}}/contentAsset/image/{{treeable.identifier}}/fileAsset/filter/Thumbnail/thumbnail_w/25/thumbnail_h/25\">\n                        <span *ngIf=\"!treeable.isImage() || treeable.extension=='ico'\" class=\"fa fa-file\" aria-hidden=\"true\"></span>\n                    </span>\n                </span>\n                    <span>{{treeable.title}}</span>\n                </ng-template>\n            </p-column>\n            <p-column field=\"type\" header=\"Type\" [sortable]=\"true\" [style]=\"{'width':'100px'}\">\n                <ng-template let-col let-treeable=\"rowData\" pTemplate type=\"body\">\n                    <span>{{treeable.displayType}}</span>\n                </ng-template>\n            </p-column>\n            <p-column field=\"live\" header=\"Status\" [style]=\"{'width':'70px'}\">\n                <ng-template let-col let-treeable=\"rowData\" pTemplate type=\"body\">\n                    <div *ngIf=\"treeable.type=='file_asset'\">\n                        <span *ngIf=\"treeable.live\" class=\"liveIcon\"></span>\n                        <span *ngIf=\"!treeable.live\" class=\"workingIcon\"></span>\n                    </div>\n                </ng-template>\n            </p-column>\n            <p-column field=\"modUserName\" header=\"Editor\" [sortable]=\"true\" [style]=\"{'width':'150px'}\"></p-column>\n            <p-column field=\"modDate\" header=\"Modified\" [sortable]=\"true\" [style]=\"{'width':'200px'}\">\n                <ng-template let-col let-treeable=\"rowData\" pTemplate type=\"body\">\n                    <span>{{treeable.modDate | date: 'MM/dd/yy hh:mm:ss a'}}</span>\n                </ng-template>\n            </p-column>\n        </p-dataTable>\n    </div>"
            },] },
];
/** @nocollapse */
SiteDatatableComponent.ctorParameters = function () { return [
    { type: SiteBrowserState, },
    { type: FileService, },
    { type: SiteBrowserService, },
    { type: SettingsStorageService, },
    { type: NotificationService, },
]; };
var DotSiteDatatableModule = (function () {
    function DotSiteDatatableModule() {
    }
    return DotSiteDatatableModule;
}());
DotSiteDatatableModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                declarations: [SiteDatatableComponent],
                exports: [SiteDatatableComponent],
                imports: [_angular_common.CommonModule, primeng_components_datatable_datatable.DataTableModule],
                providers: [FileService, SiteBrowserService, SettingsStorageService, NotificationService]
            },] },
];
/** @nocollapse */
DotSiteDatatableModule.ctorParameters = function () { return []; };

var SiteDatagridComponent = (function () {
    function SiteDatagridComponent(updateService, fileService, siteBrowserService, settingsStorageService, folderService, fileSearchService) {
        var _this = this;
        this.updateService = updateService;
        this.fileService = fileService;
        this.siteBrowserService = siteBrowserService;
        this.settingsStorageService = settingsStorageService;
        this.folderService = folderService;
        this.fileSearchService = fileSearchService;
        this.dotCMSURL = '';
        this.uploadedFiles = [];
        if (settingsStorageService.getSettings()) {
            this.dotCMSURL = settingsStorageService.getSettings().site;
        }
        this.site = updateService.getSelectedSite();
        if (updateService.getURI()) {
            this.loadFolder(updateService.getURI());
        }
        updateService.currentSite
            .subscribe(function (site) {
            if (site) {
                _this.loadSite(site);
            }
        });
        fileSearchService.searchQuery
            .subscribe(function (searchQuery) {
            if (searchQuery && searchQuery.trim() !== '') {
                updateService.changeURI(null);
                _this.loadSearchResults(searchQuery);
            }
            else {
                if (updateService.getSelectedFolder() != null && updateService.getSelectedFolder().trim() !== '') {
                    if (updateService.getURI()) {
                        _this.loadFolder(updateService.getURI());
                    }
                }
                else {
                    if (updateService.getSelectedSite()) {
                        _this.loadSite(updateService.getSelectedSite());
                    }
                }
            }
        });
        updateService.currentURI
            .subscribe(function (uri) {
            if (uri) {
                _this.loadFolder(uri);
            }
        });
        setTimeout(function () {
        }, 100);
    }
    SiteDatagridComponent.prototype.ngOnInit = function () {
    };
    SiteDatagridComponent.prototype.loadSearchResults = function (searchQuery) {
        var _this = this;
        if (searchQuery !== null && searchQuery.trim().length > 0) {
            searchQuery.trim();
            searchQuery = searchQuery + '*';
            searchQuery = searchQuery.split(' ').join('* ');
            searchQuery = '+baseType:4%20+(' + (this.site && this.site.identifier ? 'conhost:' + this.site.identifier : '') + '%20conhost:SYSTEM_HOST)%20+deleted:false%20+working:true%20+_all:(' + searchQuery + ')/orderby/modDate%20desc';
            this.fileSearchService.search(searchQuery)
                .subscribe(function (treeables) { return _this.treeables = treeables; });
            setTimeout(function () {
            }, 100);
        }
    };
    SiteDatagridComponent.prototype.loadFolder = function (uri) {
        var _this = this;
        this.siteBrowserService.getTreeableAssetsUnderFolder(this.site.hostname, uri)
            .subscribe(function (treeables) { return _this.treeables = treeables; });
        setTimeout(function () { }, 100);
    };
    SiteDatagridComponent.prototype.loadSite = function (site) {
        var _this = this;
        this.site = site;
        this.siteBrowserService.getTreeableAssetsUnderSite(site.hostname)
            .subscribe(function (treeables) { return _this.treeables = treeables; });
        setTimeout(function () { }, 100);
    };
    SiteDatagridComponent.prototype.selectTreeable = function (treeable) {
        this.updateService.changeURI(treeable.path);
    };
    SiteDatagridComponent.prototype.displayDetails = function (file) {
        this.displayDialog = true;
        this.selectedFile = file;
    };
    SiteDatagridComponent.prototype.displayUpload = function (file) {
        this.uploadDialog = true;
    };
    SiteDatagridComponent.prototype.onDialogHide = function () {
        this.selectedFile = null;
    };
    SiteDatagridComponent.prototype.onUploadHide = function () { };
    SiteDatagridComponent.prototype.addFileToUpload = function (e) {
        for (var _i = 0, _a = e.files; _i < _a.length; _i++) {
            var file = _a[_i];
            this.uploadedFiles.push(file);
        }
    };
    SiteDatagridComponent.prototype.clearUploads = function (e) {
        this.uploadedFiles = [];
    };
    SiteDatagridComponent.prototype.onUpload = function (e) {
        var _this = this;
        var uri = this.updateService.getURI();
        this.folderService.loadFolderByURI(this.site.hostname, uri)
            .subscribe(function (folder) { return _this.uploadIntoFolder(folder, e.files); });
        setTimeout(function () { }, 100);
        return;
    };
    SiteDatagridComponent.prototype.uploadIntoFolder = function (folder, files) {
        var _this = this;
        var fileContentTypeID = folder.defaultFileType;
        for (var i = 0; i < files.length; i++) {
            var file = files[i];
            this.fileService.uploadFile(file, folder.path, fileContentTypeID);
        }
        console.log('Uploaded all files');
        this.uploadedFiles = [];
        this.fieldUpload.clear();
        this.uploadDialog = false;
        // Needs to be updated so the file service returns errors and messages and then load on sucussfull upload
        setTimeout(function () {
            _this.loadFolder(_this.updateService.getURI());
        }, 2000);
        setTimeout(function () {
            _this.loadFolder(_this.updateService.getURI());
        }, 2000);
        setTimeout(function () {
            _this.loadFolder(_this.updateService.getURI());
        }, 2000);
    };
    return SiteDatagridComponent;
}());
SiteDatagridComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'site-datagrid',
                styles: [require('./../app.css')],
                template: "\n    <p-dataGrid [value]=\"treeables\" [paginator]=\"true\" [rows]=\"20\" [alwaysShowPaginator]=\"false\">\n      <ng-template let-treeable pTemplate=\"item\">\n        <div style=\"padding:3px\" class=\"ui-g-12 ui-md-3\">\n          <p-panel [style]=\"{'text-align':'center'}\">\n            <span [ngSwitch]=\"treeable.type\">\n              <span *ngSwitchCase=\"'folder'\" class=\"\">\n                <a (click)=\"selectTreeable(treeable)\"><img src=\"assets/folder.png\"></a>\n              </span>\n              <span *ngSwitchCase=\"'file_asset'\">\n                <a (click)=\"displayDetails(treeable)\">\n                  <img *ngIf=\"treeable.isImage() && treeable.extension!='ico'\" src=\"{{dotCMSURL}}/contentAsset/image/{{treeable.inode}}/fileAsset/filter/Thumbnail/thumbnail_w/48/thumbnail_h/48/byInode/true\">\n                  <span *ngIf=\"!treeable.isImage() || treeable.extension=='ico'\" class=\"\" aria-hidden=\"true\">\n                    <img src=\"assets/file.png\">\n                  </span>\n                </a>\n              </span>\n            </span>\n            <div class=\"treeable-detail\">{{treeable.title}}</div>\n          </p-panel>\n        </div>\n      </ng-template>\n    </p-dataGrid>\n    <p-dialog header=\"File Details\" [closable]=\"true\" [(visible)]=\"displayDialog\" [responsive]=\"true\" showEffect=\"fade\" [modal]=\"true\" width=\"1040\" (onAfterHide)=\"onDialogHide()\">\n\n      <div class=\"ui-g\" *ngIf=\"selectedFile\">\n        <div class=\"ui-g-12 ui-md-7\">\n          <img *ngIf=\"selectedFile.isImage()\" src=\"{{dotCMSURL}}/contentAsset/image/{{selectedFile.inode}}/fileAsset/filter/Thumbnail/thumbnail_w/530/thumbnail_h/400/byInode/true\">\n          <img *ngIf=\"!selectedFile.isImage()\" src=\"{{dotCMSURL}}/dA/{{selectedFile.inode}}/225w\" onerror=\"this.style.display='none'\">\n        </div>\n        <div class=\"ui-g-12 ui-md-5\">\n          <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Inode</label></div>\n          <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"inode\" type=\"text\" pInputText [disabled]=\"true\" [(ngModel)]=\"selectedFile.inode\" /></div>\n          <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Identifier</label></div>\n          <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"identifier\" type=\"text\" pInputText [disabled]=\"true\" [(ngModel)]=\"selectedFile.identifier\" /></div>\n          <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Filename</label></div>\n          <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"fileName\" type=\"text\" pInputText [disabled]=\"true\" [(ngModel)]=\"selectedFile.fileName\" /></div>\n          <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Title</label></div>\n          <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"title\" type=\"text\" pInputText [disabled]=\"true\" [(ngModel)]=\"selectedFile.title\" /></div>\n          <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Edititor</label></div>\n          <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"modUserName\" type=\"text\" pInputText [disabled]=\"true\" [(ngModel)]=\"selectedFile.modUserName\" /></div>\n          <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Path</label></div>\n          <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"path\" type=\"text\" pInputText [disabled]=\"true\" [(ngModel)]=\"selectedFile.path\" /></div>\n          <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Mine Type</label></div>\n          <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"mimeType\" type=\"text\" pInputText [disabled]=\"true\" [(ngModel)]=\"selectedFile.mimeType\" /></div>\n        </div>\n      </div>\n    </p-dialog>"
            },] },
];
/** @nocollapse */
SiteDatagridComponent.ctorParameters = function () { return [
    { type: SiteBrowserState, },
    { type: FileService, },
    { type: SiteBrowserService, },
    { type: SettingsStorageService, },
    { type: FolderService, },
    { type: FileSearchService, },
]; };
SiteDatagridComponent.propDecorators = {
    'fieldUpload': [{ type: _angular_core.ViewChild, args: ['fileUploadWidget',] },],
};
var DotSiteDatagridModule = (function () {
    function DotSiteDatagridModule() {
    }
    return DotSiteDatagridModule;
}());
DotSiteDatagridModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                declarations: [SiteDatagridComponent],
                exports: [SiteDatagridComponent],
                imports: [primeng_primeng.DialogModule, primeng_primeng.FileUploadModule, primeng_primeng.DataGridModule, _angular_common.CommonModule, primeng_primeng.PanelModule, _angular_forms.FormsModule],
                providers: []
            },] },
];
/** @nocollapse */
DotSiteDatagridModule.ctorParameters = function () { return []; };

var SiteTreetableService = (function () {
    function SiteTreetableService(siteBrowserService) {
        this.siteBrowserService = siteBrowserService;
        this.siteBrowserService = siteBrowserService;
    }
    /**
     * Returns the assets under a site/host
     * @param siteName
     * @returns {Observable<R>}
     */
    SiteTreetableService.prototype.getAssetsUnderSite = function (siteName) {
        var _this = this;
        var lazyFiles;
        return this.siteBrowserService.getTreeableAssetsUnderSite(siteName)
            .map(function (treeables) { return _this.extractDataFilter(treeables); });
    };
    /**
     * Returns the assets under a folder
     * @param siteName
     * @param uri
     * @returns {Observable<R>}
     */
    SiteTreetableService.prototype.getAssetsUnderFolder = function (siteName, uri) {
        var _this = this;
        var lazyFiles;
        return this.siteBrowserService.getTreeableAssetsUnderFolder(siteName, uri)
            .map(function (treeables) { return _this.extractDataFilter(treeables); });
    };
    SiteTreetableService.prototype.extractDataFilter = function (treeables) {
        var assets = [];
        for (var i = 0; i < treeables.length; i++) {
            var treeable = treeables[i];
            var leaf = true;
            if (treeable.type === 'folder') {
                leaf = false;
            }
            else if (treeable.type === 'file_asset') {
                treeable.type = 'file';
            }
            var treeNode = {
                data: treeable,
                leaf: leaf
            };
            // console.log(treeable);
            assets[i] = treeNode;
        }
        return assets;
    };
    return SiteTreetableService;
}());
SiteTreetableService.decorators = [
    { type: _angular_core.Injectable },
    { type: _angular_core.Inject, args: ['siteBrowserService',] },
];
/** @nocollapse */
SiteTreetableService.ctorParameters = function () { return [
    { type: SiteBrowserService, },
]; };

var SiteTreeTableComponent = (function () {
    function SiteTreeTableComponent(updateService, siteTreetableService, messageService) {
        var _this = this;
        this.updateService = updateService;
        this.siteTreetableService = siteTreetableService;
        this.messageService = messageService;
        this.dropzoneStylesVisible = true;
        this.site = updateService.getSelectedSite();
        if (updateService.getURI()) {
            this.loadFolder(updateService.getURI());
        }
        this.subscription = updateService.currentSite
            .subscribe(function (site) {
            if (site) {
                _this.loadHost(site);
            }
        });
        this.subscription = updateService.currentURI
            .subscribe(function (uri) {
            if (uri) {
                _this.loadFolder(uri);
            }
        });
        setTimeout(function () {
        }, 100);
    }
    /**
     * Deals with the style for the drag and drop of files
     * @param e
     */
    SiteTreeTableComponent.prototype.handleDragOver = function (e) {
        this.dropzoneStylesVisible = true;
    };
    /**
     * Handles uploading files on drag and drop
     * @param e
     */
    SiteTreeTableComponent.prototype.handleDrop = function (e) {
        e.preventDefault();
        var pathToUploadTo;
        var files = e.dataTransfer.files;
        var folderTitle = e.path[0].innerText;
        for (var i = 0; i < this.lazyFiles.length; i++) {
            var node = this.lazyFiles[i];
            if (node.data.title === folderTitle && node.data.type === 'folder') {
                pathToUploadTo = node.data.path;
                break;
            }
        }
        this.messageService.displayInfoMessage('Path is ' + pathToUploadTo);
        return;
    };
    /**
     * Loads the objects under a host
     * @param siteName
     */
    SiteTreeTableComponent.prototype.loadHost = function (site) {
        var _this = this;
        this.site = site;
        this.siteTreetableService.getAssetsUnderSite(site.hostname)
            .subscribe(function (items) { return _this.lazyFiles = items; });
        setTimeout(function () {
        }, 100);
    };
    /**
     * Loades the objects under a folder
     * @param uri
     */
    SiteTreeTableComponent.prototype.loadFolder = function (uri) {
        var _this = this;
        this.siteTreetableService.getAssetsUnderFolder(this.site.hostname, uri)
            .subscribe(function (items) { return _this.lazyFiles = items; });
        setTimeout(function () {
        }, 100);
    };
    /**
     * Handle clicking a node ie.. to show detail on a folder or file
     * @param event
     */
    SiteTreeTableComponent.prototype.nodeSelect = function (event) {
        this.msgs = [];
        this.msgs.push({ severity: 'info', summary: 'Node Selected', detail: event.node.data.name });
    };
    /**
     * Unselects the selected node ie... file or folder
     * @param event
     */
    SiteTreeTableComponent.prototype.nodeUnselect = function (event) {
        this.msgs = [];
        this.msgs.push({ severity: 'info', summary: 'Node Unselected', detail: event.node.data.name });
    };
    /**
     * Expands a node ie.. a folder
     * @param event
     */
    SiteTreeTableComponent.prototype.nodeExpand = function (event) {
        var _this = this;
        var pathName = event.node.data.path;
        pathName = pathName.slice(0, pathName.length - 1);
        pathName = pathName.slice(pathName.lastIndexOf('/') + 1, pathName.length);
        this.updateService.changeFolder(pathName);
        this.updateService.changeURI(event.node.data.path);
        if (event.node) {
            this.siteTreetableService.getAssetsUnderFolder(this.site.hostname, event.node.data.path)
                .subscribe(function (items) { return _this.lazyFiles = items; });
        }
        setTimeout(function () {
        }, 100);
    };
    return SiteTreeTableComponent;
}());
SiteTreeTableComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'site-treetable',
                styles: [require('./../app.css')],
                template: "<div class=\"ContentSideSections Implementation\"\n                    (drop)=\"handleDrop($event, p-column)\" (dragover)=\"handleDragOver($event)\">\n        <p-treeTable [value]=\"lazyFiles\" [(selection)]=\"selectedNode\" [style]=\"&#123;'margin-top':'30px'&#125;\"\n                     (onNodeExpand)=\"nodeExpand($event)\" selectionMode=\"single\">\n            <p-column class=\"browser-dropzone\" field=\"title\" header=\"Name\"></p-column>\n            <p-column field=\"modDate\" header=\"Mod Date\" [style]=\"&#123;'width': '100px'&#125;\"></p-column>\n            <p-column field=\"type\" header=\"Type\" [style]=\"&#123;'width': '65px'&#125;\"></p-column>\n        </p-treeTable>\n    </div>"
            },] },
    { type: _angular_core.Inject, args: ['updateService',] },
];
/** @nocollapse */
SiteTreeTableComponent.ctorParameters = function () { return [
    { type: SiteBrowserState, },
    { type: SiteTreetableService, },
    { type: NotificationService, },
]; };
var DotSiteTreeTableModule = (function () {
    function DotSiteTreeTableModule() {
    }
    return DotSiteTreeTableModule;
}());
DotSiteTreeTableModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                declarations: [SiteTreeTableComponent],
                exports: [SiteTreeTableComponent],
                imports: [_angular_common.CommonModule, primeng_components_treetable_treetable.TreeTableModule],
                providers: [SiteTreetableService, NotificationService]
            },] },
];
/** @nocollapse */
DotSiteTreeTableModule.ctorParameters = function () { return []; };

var TreeableDetailComponent = (function () {
    function TreeableDetailComponent(updateService, settingsStorageService) {
        var _this = this;
        this.updateService = updateService;
        this.settingsStorageService = settingsStorageService;
        this.dotCMSURL = '';
        this.treeable = new Treeable();
        if (settingsStorageService.getSettings() !== null) {
            this.dotCMSURL = settingsStorageService.getSettings().site;
        }
        if (updateService.getSelectedTreeable()) {
            this.treeable = updateService.getSelectedTreeable();
        }
        this.subscription = updateService.currentTreeable
            .subscribe(function (treeable) {
            if (treeable) {
                _this.treeable = treeable;
            }
            else {
                _this.treeable = new Treeable();
            }
        });
        setTimeout(function () {
        }, 100);
    }
    return TreeableDetailComponent;
}());
TreeableDetailComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'treeable-detail',
                styles: [require('./../app.css')],
                template: "<div *ngIf=\"treeable.type=='file_asset'\">\n        <div>\n            <img *ngIf=\"treeable.isImage() && treeable.extension!='ico'\" src=\"{{dotCMSURL}}/contentAsset/image/{{treeable.identifier}}/fileAsset/filter/Thumbnail/thumbnail_w/225/thumbnail_h/225\">\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Inode</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"inode\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.inode\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Identifier</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"identifier\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.identifier\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Filename</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"fileName\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.fileName\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Title</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"title\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.title\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Edititor</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"modUserName\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.modUserName\" /></div>\n        </div>\n\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Path</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"path\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.path\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Mine Type</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"mimeType\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.mimeType\" /></div>\n        </div>\n    </div>\n\n    <div *ngIf=\"treeable.type=='folder'\">\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Inode</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"inode\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.inode\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Identifier</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"identifier\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.identifier\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Name</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"name\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.name\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Title</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"title\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.title\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Path</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"path\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.path\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Show On Menu</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"showOnMenu\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.showOnMenu\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Default File Type</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"defaultFileType\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.defaultFileType\" /></div>\n        </div>\n    </div>"
            },] },
];
/** @nocollapse */
TreeableDetailComponent.ctorParameters = function () { return [
    { type: SiteBrowserState, },
    { type: SettingsStorageService, },
]; };
var DotTreeableDetailModule = (function () {
    function DotTreeableDetailModule() {
    }
    return DotTreeableDetailModule;
}());
DotTreeableDetailModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                declarations: [TreeableDetailComponent],
                exports: [TreeableDetailComponent],
                imports: [_angular_common.CommonModule, _angular_forms.FormsModule, primeng_components_inputtext_inputtext.InputTextModule],
                providers: [SettingsStorageService]
            },] },
];
/** @nocollapse */
DotTreeableDetailModule.ctorParameters = function () { return []; };

// SERVICES

exports.AppConfig = AppConfig;
exports.FileService = FileService;
exports.DotFileModule = DotFileModule;
exports.FileSearchService = FileSearchService;
exports.HttpClient = HttpClient;
exports.DotHttpModule = DotHttpModule;
exports.JWTAuthService = JWTAuthService;
exports.DotJWTAuthModule = DotJWTAuthModule;
exports.LocalStoreService = LocalStoreService;
exports.DotLocalStoreModule = DotLocalStoreModule;
exports.NotificationService = NotificationService;
exports.DotNotificationModule = DotNotificationModule;
exports.SettingsStorageService = SettingsStorageService;
exports.DotSettingsStorageModule = DotSettingsStorageModule;
exports.SiteBrowserService = SiteBrowserService;
exports.DotSiteBrowserModule = DotSiteBrowserModule;
exports.SiteBrowserState = SiteBrowserState;
exports.FolderService = FolderService;
exports.DotFolderModule = DotFolderModule;
exports.ApiRoot = ApiRoot;
exports.Config = Config;
exports.RULE_CREATE = RULE_CREATE;
exports.RULE_DELETE = RULE_DELETE;
exports.RULE_UPDATE_NAME = RULE_UPDATE_NAME;
exports.RULE_UPDATE_ENABLED_STATE = RULE_UPDATE_ENABLED_STATE;
exports.V_RULE_UPDATE_EXPANDED_STATE = V_RULE_UPDATE_EXPANDED_STATE;
exports.RULE_UPDATE_FIRE_ON = RULE_UPDATE_FIRE_ON;
exports.RULE_RULE_ACTION_CREATE = RULE_RULE_ACTION_CREATE;
exports.RULE_RULE_ACTION_DELETE = RULE_RULE_ACTION_DELETE;
exports.RULE_RULE_ACTION_UPDATE_TYPE = RULE_RULE_ACTION_UPDATE_TYPE;
exports.RULE_RULE_ACTION_UPDATE_PARAMETER = RULE_RULE_ACTION_UPDATE_PARAMETER;
exports.RULE_CONDITION_GROUP_UPDATE_OPERATOR = RULE_CONDITION_GROUP_UPDATE_OPERATOR;
exports.RULE_CONDITION_GROUP_DELETE = RULE_CONDITION_GROUP_DELETE;
exports.RULE_CONDITION_GROUP_CREATE = RULE_CONDITION_GROUP_CREATE;
exports.RULE_CONDITION_CREATE = RULE_CONDITION_CREATE;
exports.RULE_CONDITION_DELETE = RULE_CONDITION_DELETE;
exports.RULE_CONDITION_UPDATE_TYPE = RULE_CONDITION_UPDATE_TYPE;
exports.RULE_CONDITION_UPDATE_PARAMETER = RULE_CONDITION_UPDATE_PARAMETER;
exports.RULE_CONDITION_UPDATE_OPERATOR = RULE_CONDITION_UPDATE_OPERATOR;
exports.CoreWebService = CoreWebService;
exports.DotcmsConfig = DotcmsConfig;
exports.DotcmsEventsService = DotcmsEventsService;
exports.LoggerService = LoggerService;
exports.LoginService = LoginService;
exports.SiteService = SiteService;
exports.SocketFactory = SocketFactory;
exports.StringUtils = StringUtils;
exports.BrowserUtil = BrowserUtil;
exports.DotRouterService = DotRouterService;
exports.RoutingService = RoutingService;
exports.HttpRequestUtils = HttpRequestUtils;
exports.NETWORK_CONNECTION_ERROR = NETWORK_CONNECTION_ERROR;
exports.UNKNOWN_RESPONSE_ERROR = UNKNOWN_RESPONSE_ERROR;
exports.SERVER_RESPONSE_ERROR = SERVER_RESPONSE_ERROR;
exports.CLIENTS_ONLY_MESSAGES = CLIENTS_ONLY_MESSAGES;
exports.CwError = CwError;
exports.isSuccess = isSuccess;
exports.hasContent = hasContent;
exports.LongPollingProtocol = LongPollingProtocol;
exports.Url = Url;
exports.Protocol = Protocol;
exports.ResponseView = ResponseView;
exports.EventsSocket = EventsSocket;
exports.WebSocketProtocol = WebSocketProtocol;
exports.BreadcrumbComponent = BreadcrumbComponent;
exports.DotBreadcrumbModule = DotBreadcrumbModule;
exports.BreadcrumbHostselectorComponent = BreadcrumbHostselectorComponent;
exports.DotBreadcrumbHostselectorModule = DotBreadcrumbHostselectorModule;
exports.SiteDatatableComponent = SiteDatatableComponent;
exports.DotSiteDatatableModule = DotSiteDatatableModule;
exports.SiteDatagridComponent = SiteDatagridComponent;
exports.DotSiteDatagridModule = DotSiteDatagridModule;
exports.SiteSelectorComponent = SiteSelectorComponent;
exports.DotSiteSelectorModule = DotSiteSelectorModule;
exports.SiteTreeTableComponent = SiteTreeTableComponent;
exports.DotSiteTreeTableModule = DotSiteTreeTableModule;
exports.TreeableDetailComponent = TreeableDetailComponent;
exports.DotTreeableDetailModule = DotTreeableDetailModule;
exports.SiteSelectorService = SiteSelectorService;
exports.SiteTreetableService = SiteTreetableService;
exports.DotSettings = DotSettings;
exports.UserModel = UserModel;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=amazing.umd.js.map
