import { MenuItem } from 'primeng/components/common/api';
import { SiteBrowserState } from '../../core/util/site-browser.state';
import { Site } from '../../core/treeable/shared/site.model';
/**
 * The BreadcrumbComponent provides a PrimeNG Component for providing navigation with dotCMS Components
 * It can respond to the Site or Folder being changed.  In addition the navigation it provides can be clicked on
 * There is no connection to the other components directly.  The interaction is all managed by the [[SiteBrowserState]]
 */
export declare class BreadcrumbComponent {
    private updateService;
    protected pathItems: MenuItem[];
    constructor(updateService: SiteBrowserState);
    /**
     * Called when the [[SiteBrowserState]] Site is changed. This is managed via a Subscription
     * @param siteName
     */
    onSiteChange(site: Site): void;
    /**
     * Called when the [[SiteBrowserState]] Folder is changed. This is managed via a Subscription
     * @param folderName
     */
    onFolderClick(folderName: string): void;
    private getCurrentURI();
    private addSiteItem(site);
    private addFolderItem(folderName);
    private buildMenuItemsFromURI(uri);
}
export declare class DotBreadcrumbModule {
}
