import { OnInit } from '@angular/core';
import { FileUpload } from 'primeng/primeng';
import { Site } from '../../core/treeable/shared/site.model';
import { Treeable } from '../../core/treeable/shared/treeable.model';
import { SiteBrowserState } from '../../core/util/site-browser.state';
import { FileService } from '../../core/file/file.services';
import { SiteBrowserService } from '../../core/util/site-browser.service';
import { SettingsStorageService } from '../../core/util/settings-storage.service';
import { FolderService } from '../../core/util/folder.service';
import { FileSearchService } from '../../core/file/file-search.service';
import { Folder } from '../../core/treeable/shared/folder.model';
export declare class SiteDatagridComponent implements OnInit {
    private updateService;
    private fileService;
    private siteBrowserService;
    private settingsStorageService;
    private folderService;
    private fileSearchService;
    fieldUpload: FileUpload;
    dotCMSURL: string;
    site: Site;
    treeables: Treeable[];
    displayDialog: boolean;
    uploadDialog: boolean;
    selectedFile: File;
    uploadedFiles: any[];
    searchQuery: string;
    constructor(updateService: SiteBrowserState, fileService: FileService, siteBrowserService: SiteBrowserService, settingsStorageService: SettingsStorageService, folderService: FolderService, fileSearchService: FileSearchService);
    ngOnInit(): void;
    loadSearchResults(searchQuery: string): void;
    loadFolder(uri: string): void;
    loadSite(site: Site): void;
    selectTreeable(treeable: Folder): void;
    displayDetails(file: File): void;
    displayUpload(file: File): void;
    onDialogHide(): void;
    onUploadHide(): void;
    addFileToUpload(e: any): void;
    clearUploads(e: any): void;
    onUpload(e: any): void;
    private uploadIntoFolder(folder, files);
}
export declare class DotSiteDatagridModule {
}
