import { Observable } from 'rxjs';
import { HttpClient } from '../../core/util/http.service';
import { NotificationService } from '../../core/util/notification.service';
import { Site } from '../../core/treeable/shared/site.model';
export declare class SiteSelectorService {
    private dotHttpClient;
    private notificationService;
    constructor(dotHttpClient: HttpClient, notificationService: NotificationService);
    /**
     * Returns a list of sites searcing the hostname
     * @param searchQuery
     * @returns {Observable<R|T>}
     */
    filterForSites(searchQuery: string): Observable<Site[]>;
    /**
     * Returns all sites
     * @returns {Observable<R|T>}
     */
    getSites(): Observable<Site[]>;
    private extractDataDropdown(res);
    private extractDataFilter(res);
    private handleError(error);
}
