import { Message, TreeNode } from 'primeng/components/common/api';
import { Subscription } from 'rxjs';
import { SiteTreetableService } from './site-treetable.service';
import { SiteBrowserState } from '../../core/util/site-browser.state';
import { NotificationService } from '../../core/util/notification.service';
import { Site } from '../../core/treeable/shared/site.model';
export declare class SiteTreeTableComponent {
    private updateService;
    private siteTreetableService;
    private messageService;
    dropzoneStylesVisible: boolean;
    site: Site;
    msgs: Message[];
    lazyFiles: TreeNode[];
    selectedNode: TreeNode;
    subscription: Subscription;
    constructor(updateService: SiteBrowserState, siteTreetableService: SiteTreetableService, messageService: NotificationService);
    /**
     * Deals with the style for the drag and drop of files
     * @param e
     */
    handleDragOver(e: any): void;
    /**
     * Handles uploading files on drag and drop
     * @param e
     */
    handleDrop(e: any): void;
    /**
     * Loads the objects under a host
     * @param siteName
     */
    loadHost(site: Site): void;
    /**
     * Loades the objects under a folder
     * @param uri
     */
    loadFolder(uri: string): void;
    /**
     * Handle clicking a node ie.. to show detail on a folder or file
     * @param event
     */
    nodeSelect(event: any): void;
    /**
     * Unselects the selected node ie... file or folder
     * @param event
     */
    nodeUnselect(event: any): void;
    /**
     * Expands a node ie.. a folder
     * @param event
     */
    nodeExpand(event: any): void;
}
export declare class DotSiteTreeTableModule {
}
