import { Component, NgModule } from '@angular/core';
import { Treeable } from '../../core/treeable/shared/treeable.model';
import { SiteBrowserState } from '../../core/util/site-browser.state';
import { SettingsStorageService } from '../../core/util/settings-storage.service';
import { CommonModule } from '@angular/common';
import { InputTextModule } from 'primeng/components/inputtext/inputtext';
import { FormsModule } from '@angular/forms';
var TreeableDetailComponent = (function () {
    function TreeableDetailComponent(updateService, settingsStorageService) {
        var _this = this;
        this.updateService = updateService;
        this.settingsStorageService = settingsStorageService;
        this.dotCMSURL = '';
        this.treeable = new Treeable();
        if (settingsStorageService.getSettings() !== null) {
            this.dotCMSURL = settingsStorageService.getSettings().site;
        }
        if (updateService.getSelectedTreeable()) {
            this.treeable = updateService.getSelectedTreeable();
        }
        this.subscription = updateService.currentTreeable
            .subscribe(function (treeable) {
            if (treeable) {
                _this.treeable = treeable;
            }
            else {
                _this.treeable = new Treeable();
            }
        });
        setTimeout(function () {
        }, 100);
    }
    return TreeableDetailComponent;
}());
export { TreeableDetailComponent };
TreeableDetailComponent.decorators = [
    { type: Component, args: [{
                selector: 'treeable-detail',
                styles: [require('./../app.css')],
                template: "<div *ngIf=\"treeable.type=='file_asset'\">\n        <div>\n            <img *ngIf=\"treeable.isImage() && treeable.extension!='ico'\" src=\"{{dotCMSURL}}/contentAsset/image/{{treeable.identifier}}/fileAsset/filter/Thumbnail/thumbnail_w/225/thumbnail_h/225\">\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Inode</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"inode\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.inode\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Identifier</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"identifier\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.identifier\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Filename</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"fileName\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.fileName\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Title</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"title\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.title\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Edititor</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"modUserName\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.modUserName\" /></div>\n        </div>\n\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Path</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"path\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.path\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Mine Type</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"mimeType\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.mimeType\" /></div>\n        </div>\n    </div>\n\n    <div *ngIf=\"treeable.type=='folder'\">\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Inode</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"inode\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.inode\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Identifier</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"identifier\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.identifier\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Name</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"name\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.name\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Title</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"title\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.title\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Path</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"path\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.path\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Show On Menu</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"showOnMenu\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.showOnMenu\" /></div>\n        </div>\n        <div class=\"ui-g\">\n            <div class=\"ui-g-3\"><label class=\"treeable-detail-label\">Default File Type</label></div>\n            <div class=\"ui-g-9\"><input class=\"treeable-detail-input\" id=\"defaultFileType\" type=\"text\" pInputText [disabled]=\"disabled\" [(ngModel)]=\"treeable.defaultFileType\" /></div>\n        </div>\n    </div>"
            },] },
];
/** @nocollapse */
TreeableDetailComponent.ctorParameters = function () { return [
    { type: SiteBrowserState, },
    { type: SettingsStorageService, },
]; };
var DotTreeableDetailModule = (function () {
    function DotTreeableDetailModule() {
    }
    return DotTreeableDetailModule;
}());
export { DotTreeableDetailModule };
DotTreeableDetailModule.decorators = [
    { type: NgModule, args: [{
                declarations: [TreeableDetailComponent],
                exports: [TreeableDetailComponent],
                imports: [CommonModule, FormsModule, InputTextModule],
                providers: [SettingsStorageService]
            },] },
];
/** @nocollapse */
DotTreeableDetailModule.ctorParameters = function () { return []; };
//# sourceMappingURL=treeable-detail.component.js.map