import { Http, RequestOptionsArgs } from '@angular/http';
import { Observable } from 'rxjs/Rx';
import { ApiRoot } from './api-root.service';
import { ResponseView } from './util/response-view';
import { LoggerService } from './logger.service';
import { BrowserUtil } from './browser-util.service';
export declare const RULE_CREATE = "RULE_CREATE";
export declare const RULE_DELETE = "RULE_DELETE";
export declare const RULE_UPDATE_NAME = "RULE_UPDATE_NAME";
export declare const RULE_UPDATE_ENABLED_STATE = "RULE_UPDATE_ENABLED_STATE";
export declare const V_RULE_UPDATE_EXPANDED_STATE = "V_RULE_UPDATE_EXPANDED_STATE";
export declare const RULE_UPDATE_FIRE_ON = "RULE_UPDATE_FIRE_ON";
export declare const RULE_RULE_ACTION_CREATE = "RULE_RULE_ACTION_CREATE";
export declare const RULE_RULE_ACTION_DELETE = "RULE_RULE_ACTION_DELETE";
export declare const RULE_RULE_ACTION_UPDATE_TYPE = "RULE_RULE_ACTION_UPDATE_TYPE";
export declare const RULE_RULE_ACTION_UPDATE_PARAMETER = "RULE_RULE_ACTION_UPDATE_PARAMETER";
export declare const RULE_CONDITION_GROUP_UPDATE_OPERATOR = "RULE_CONDITION_GROUP_UPDATE_OPERATOR";
export declare const RULE_CONDITION_GROUP_DELETE = "RULE_CONDITION_GROUP_DELETE";
export declare const RULE_CONDITION_GROUP_CREATE = "RULE_CONDITION_GROUP_CREATE";
export declare const RULE_CONDITION_CREATE = "RULE_CONDITION_CREATE";
export declare const RULE_CONDITION_DELETE = "RULE_CONDITION_DELETE";
export declare const RULE_CONDITION_UPDATE_TYPE = "RULE_CONDITION_UPDATE_TYPE";
export declare const RULE_CONDITION_UPDATE_PARAMETER = "RULE_CONDITION_UPDATE_PARAMETER";
export declare const RULE_CONDITION_UPDATE_OPERATOR = "RULE_CONDITION_UPDATE_OPERATOR";
export declare class CoreWebService {
    private _apiRoot;
    private _http;
    private loggerService;
    private browserUtil;
    private httpErrosSubjects;
    constructor(_apiRoot: ApiRoot, _http: Http, loggerService: LoggerService, browserUtil: BrowserUtil);
    request(options: any): Observable<any>;
    /**
   * Return a response adapted to the follow json format:
   *
   * <code>
   * {
   *   "errors":[],
   *   "entity":{},
   *   "messages":[],
   *   "i18nMessagesMap":{}
   * }
   * </code>
   *
   * @param options
   * @returns {DotCMSHttpResponse}
   */
    requestView(options: RequestOptionsArgs): Observable<ResponseView>;
    private handleRequestViewErrors(resp);
    subscribeTo(httpErrorCode: number): Observable<any>;
    private getRequestOpts(options);
    private handleHttpError(response);
}
