import { CoreWebService } from './core-web.service';
import { Observable } from 'rxjs/Rx';
import { LoggerService } from './logger.service';
import { Menu } from './routing.service';
export interface ConfigParams {
    colors: object;
    disabledWebsockets: string;
    emailRegex: string;
    license: object;
    menu: Menu[];
    paginatorLinks: number;
    paginatorRows: number;
    websocketBaseURL: string;
    websocketEndpoints: string;
    websocketProtocol: string;
    websocketReconnectTime: number;
    websocketsSystemEventsEndpoint: string;
}
export declare class DotcmsConfig {
    private coreWebService;
    private loggerService;
    private waiting;
    private configParams;
    private configUrl;
    /**
     * Initializes this class with the dotCMS core configuration parameters.
     *
     * @param configParams - The configuration properties for the current instance.
     */
    constructor(coreWebService: CoreWebService, loggerService: LoggerService);
    getConfig(): Observable<ConfigParams>;
    loadConfig(): void;
}
