import { Observable } from 'rxjs/Rx';
import { LoggerService } from './logger.service';
import { SocketFactory } from './socket-factory.service';
export declare class DotcmsEventsService {
    private socketFactory;
    private loggerService;
    private socket;
    private subjects;
    constructor(socketFactory: SocketFactory, loggerService: LoggerService);
    /**
     * Close the socket
     */
    destroy(): void;
    /**
     * Start the socket
     */
    start(): void;
    /**
     * This method will be called by clients that want to receive notifications
     * regarding incoming system events. The events they will receive will be
     * based on the type of event clients register for.
     *
     * @param clientEventType - The type of event clients will get. For example,
     *                          "notification" will allow a client to receive the
     *                          messages in the Notification section.
     * @returns {any} The system events that a client will receive.
     */
    subscribeTo(clientEventType: string): Observable<any>;
    subscribeToEvents(clientEventTypes: string[]): Observable<EventTypeWrapper>;
}
export interface EventTypeWrapper {
    data: any;
    eventType: string;
}
