import { Logger } from 'angular2-logger/core';
import { Config } from './config.service';
import { StringUtils } from './string-utils.service';
/**
 * LoggerService to log.  Allows logger to be changed at runtime
 * To set the logger level in the console run logger.level=logger.Level.DEBUG
 */
export declare class LoggerService {
    private config;
    private logger;
    private stringUtils;
    private showLogs;
    private httpRequestUtils;
    constructor(config: Config, logger: Logger, stringUtils: StringUtils);
    info(message?: any, ...optionalParams: any[]): void;
    error(message?: any, ...optionalParams: any[]): void;
    warn(message?: any, ...optionalParams: any[]): void;
    debug(message?: any, ...optionalParams: any[]): void;
    /**
     * Determine if angular should show lo
     * @returns {boolean}
     */
    shouldShowLogs(): boolean;
    private wrapMessage(message?);
    private getCaller();
    private cleanCaller(caller);
}
