import { CoreWebService } from './core-web.service';
import { LoginService } from './login.service';
import { Observable } from 'rxjs/Rx';
import { DotcmsEventsService } from './dotcms-events.service';
import { DotRouterService } from './dot-router.service';
export declare class RoutingService {
    private router;
    private coreWebService;
    private _menusChange$;
    private menus;
    private urlMenus;
    private portlets;
    private _currentPortletId;
    private _portletUrlSource$;
    private _currentPortlet$;
    constructor(loginService: LoginService, router: DotRouterService, coreWebService: CoreWebService, dotcmsEventsService: DotcmsEventsService);
    readonly currentPortletId: string;
    readonly currentMenu: Menu[];
    readonly menusChange$: Observable<Menu[]>;
    readonly portletUrl$: Observable<string>;
    readonly firstPortlet: string;
    addPortletURL(portletId: string, url: string): void;
    getPortletURL(portletId: string): string;
    goToPortlet(portletId: string): void;
    isPortlet(url: string): boolean;
    setCurrentPortlet(url: string): void;
    readonly currentPortlet$: Observable<string>;
    setMenus(menus: Menu[]): void;
    /**
     * Refresh the portlet displayed. with the
     * @param url portlet url
     */
    changeRefreshPortlet(url: string): void;
    private loadMenus();
    private getPortletId(url);
}
export interface Menu {
    tabDescription: string;
    tabName: string;
    url: string;
    menuItems: MenuItem[];
}
export interface MenuItem {
    ajax: boolean;
    angular: boolean;
    id: string;
    name: string;
    url: string;
    menuLink: string;
}
