import { HttpClient } from './http.service';
import { NotificationService } from './notification.service';
import { Folder } from '../treeable/shared/folder.model';
import { Observable } from 'rxjs/Observable';
/**
 * Service allows opertions against dotCMS Folder Endpoints and Operations
 */
export declare class FolderService {
    private httpClient;
    private notificationService;
    constructor(httpClient: HttpClient, notificationService: NotificationService);
    /**
     * Load a folder from the remote dotCMS server based on site and path
     * @param {String} siteName The site name for the uri/folder
     * @param {String} uri The folder path
     */
    loadFolderByURI(siteName: String, uri: String): Observable<Folder>;
    private extractDataFilter(res);
    private handleError(error);
}
export declare class DotFolderModule {
}
