import { Protocol, Url } from './protocol';
import { LoggerService } from '../logger.service';
import { CoreWebService } from '../core-web.service';
import { ConfigParams } from '../dotcms-config.service';
export declare class EventsSocket extends Protocol {
    private url;
    private coreWebService;
    private protocolImpl;
    private closedOnLogout;
    private isWebSocketServerSupport;
    private status;
    private lastcallback;
    /**
     * Initializes this service with the configuration properties that are
     * necessary for opening the Websocket with the System Events end-point.
     *
     * @param dotcmsConfig - The dotCMS configuration properties that include
     * the Websocket parameters.
     */
    constructor(url: Url, configParams: ConfigParams, loggerService: LoggerService, coreWebService: CoreWebService);
    start(): void;
    destroy(): void;
    private getProtocol();
    private isWebSocketsBrowserSupport();
    private isWebSocketProtocol();
}
